import {commonRender} from "../../js/commonRender";
import {AjaxUtil, Replace} from "sasp-base";
import formEvent from "../../../js/formEvent";

const tableFormMixin = {
    props:{
        useLoadSelf:{type:Boolean,default:false}, // 自主调用loadData初始化，并可以在外部确定加载完成时机回调
        tableviewId:{type:String,default:''},
        listViewId:{type:String,default:""},
        dataId:{type:String,required:false,default:''},
        addDataId:{type:String,required:false,default:''}, // 添加时外部设置的数据Id
        formOperate:{type:String,default:"add"},
        extraPath:{type:String,default:""},
        formFieldObj:{type:Object,default:() => {return {};}},
        isEditData:{type:Boolean,default:false},
        isSignForm:{type:Boolean,default:false}, //来源于单表表单预览
        isConfig:{type:Boolean,default:false}, //是否是配置层
        isFlow:{type:Boolean,default:false},//是否是工作流
        flowFieldStatus:{type:Object,default:() => {return {};}},//工作流中字段的显示状态，edit-可编辑;view-可查看不可编辑;hide-不可见;
        flowFieldDefault:{type:Object,default:() => {return {};}},//工作流设置的字段默认值
        flowFieldDefaultChangeNum:{type:Object,default:() => {return {};}},//工作流字段默认值的变更频率
        flowFieldDefaultFromForm:{type:Object,default:() => {return {};}},//工作流默认值需要根据表单数据计算的
        editParamObj:{type:Object,default:() =>{return {};}},//编辑列表默认回填字段
        editRelationId:{type:String,default:""},
        refreshData:{type:Function,default:null},
        listSearchMethod:{type:Function,default:null},
        listOutParam:{type:Object,default:() => {return {};}}, // 列表外部传入参数
        outParam:{type:Object,default:() => {return {};}}, // 外部传入参数
        parentOptFormData:{type:Object,default:() => {return {};}},//编辑列表父表单对象
        parentOptTableData:{type:Object,default:() => {return {};}},//编辑表单父表单对象
        tableFormRefObj:{type:Object,default:() => {return {};}},//编辑表单ref对象
        isCopyOperate:{type:Boolean,default:false}, //是否是复制操作
        noCopyArr:{type:Array,default:() =>{return [];}}, //是否是复制操作
        formBtnHiddenConditionObj:{type:Object,default:()=>{return {};}}, //表单隐藏条件配置
        formBtnVisbleObj:{type:Object,default:()=>{return {};}},//表单隐藏条件按钮
        formPrintVisble:{type:String,default:""},//表单已办结节点隐藏条件
        propTableviewsData:{type:Object,default:() => {return {};}},
        propDataAllObj:{type:Object,default:() => {return {};}},
        propFormData:{type:Object,default:() => {return {};}},
        propUploadFkInfo:{type:Object,default:() => {return {};}},
        propTableviewEventArr:{type:Array,default:() => {return [];}},
        propConditionEventRuleArr:{type:Array,default:() => {return [];}},
        propNewConditionEventRuleArr:{type:Array,default:() => {return [];}},
        propNewControlEventObj:{type:Object,default:() => {return {};}},
        propFieldSysDataObj:{type:Object,default:() => {return {};}},
        propControlEventObj:{type:Object,default:() => {return {};}},
        propAddCommentsFields:{type:Array,default:() => {return [];}},
        propRelationId:{type:String,default:""},
        isGroup:{type:Boolean,default:false}, // 是否是分组
        isEditTableForm:{type:Boolean,default:false}, // 是否是编辑表单
        groupArr:{type:Array,default:() => {return [];}}, // 是否是分组
        isTabs:{type:Boolean,default:false}, // 是否是tabs
        isTempEdit:{type:Boolean,default:false}, // 是否是临时编辑列表
        isFirstClick:{type:Boolean,default:false}, // 是否是tabs
        tabsArr:{type:Array,default:() => {return [];}}, // 是否是tabs
        activeTab:{type:String,default:""}, // 当前激活的tab页
        sourceId:{type:String,default:""}, // 当前使用的数据源ID
        skinParamObj: {type: Object, default: () => ({})}, // 皮肤类型Obj
    },
    data(){
        return {
            //附件上传文件类型
            fileTypeObj:{
                pic:"图片",
                word:"文本",
                excel:"表格",
                pdf:"PDF",
                powerpoint:"PPT",
                compress:"压缩文件",
                video:"视频",
                sound:"音频",
                other:"其他"
            },
            objFileTypeImgs: {
                all: ["all"],
                pic: ["jpg","png"],
                word: ["docx", "doc"],
                excel: ["xlsx", "xls"],
                powerpoint: ["ppt", "pptx"],
                compress: ["rar", "zip", "gz", "jar", "arj", "z"],
                video: ["mp4", "avi", "flv", "rmvb", "3gp", "mov", "m4v", "wmv", "asf", "asx", "rm", "dat", "mkv", "vob"],
                sound: ["mp3", "wma", "wav", "midi", "ape", "flac", "wmv"],
                pdf: ["pdf"],
                txt: ["txt"],
                project: ["mpp"],
                visio: ["vsdx", "vsd"],
                other:[],
            },
            allTd:[],
            loadDataSuccess:false,
            renderModel:"render",
            isPerview:true,
            tableviewsData:{},
            renderArr:[],
            dataAllObj:{},
            oldDataAllObj:{},
            fieldObj:{},
            optFormData:{},
            // 编辑列表需要修改的关联主表ID参数，如传入参数为ID指向子表的某个字段时，在添加完成后需要修改此字段为正确的关联ID，
            // 因为添加时主表的ID是假的，添加成功后才会update
            editFormUpdateParams:{},
            initFormData:{},
            decryptFormData: {},
            loginUser:{},
            userDept:{},
            rules: {}, //校验
            draftRules: {}, //草稿校验
            //必填前加星星*
            requiredStars: {},
            uploadFkInfo:{}, // 附件上传id信息

            editTableFormId:[],//编辑列表formId
            relationId: "",

            //脚本
            scriptDataArr:[], //总脚本arr
            scriptData: {
                add: {beforeOpen: null, afterOpen: null},
                update: {beforeOpen: null, afterOpen: null},
                view: {beforeOpen: null, afterOpen: null},
                save: {beforeSubmit: null, afterSubmit: null},
                close: {beforeClose: null, afterClose: null},
                all: {beforeOpen: null, afterOpen: null, beforeSubmit: null, afterSubmit: null, beforeClose: null, afterClose: null}
            },
            eventListener:null, //事件
            buildViewsEvent: null,
            viewsEventMap: {}, // 表单视图事件设置参数
            viewsEventBind:{},
            tableviewEventArr:[],//表单事件规则
            controlEventObj:{},//控件方式条件
            conditionEventRuleArr:[],
            affectContentOtherArr:["title","url","param","linkTitle","openType","linkUrl","dialogTitle",
                                   "selectType","dataDic","reqUrl","optionSetting","parentId","valueField","textField"],
            tempRemoveUploadFile:[],
            operate:"add",
            fieldSysDataObj:{}, // 字段对应的元数据id转name
            uploadRecord:{}, // 附件的变更记录
            formId:"",
            delayWatchData:true,
            formDefineKey:"", // 表单defineKey
            viewAdditionEdit:[], // 查看时是否可以编辑追加意见
            allLoadRuleData:{},//所有已加载的事件规则的数据
            newAllLoadRuleData:{}, //所有已经加载的事件数据
            addCommentsFields:[],//追加意见对象
            newControlEventObj:{}, //新事件规则-控件触发
            newConditionEventRuleArr:[], //新事件规则-条件触发
            installListObj:this.EVENT_PLUGIN['installEventObj']||{}, //已经安装的列表事件
            connectSignObj:{"AND":"&&","OR":"||","AND (":"&& (","OR (":"|| (","AND ((":"&& ((","OR ((":"|| (("},
            useEventFieldVisible:{},//上次执行事件后字段值
            operateRootArr:"",
            dataPermis:"",
            isTriggerOnceObj:{},//事件规则开启仅触发一次
            plUeditorObj:{},//记录富文本编辑器对象
            rightWidth:'7%',
            topHeight:'105',
            leftWidth:'114',
            defaultActive:'1',
            compositeObj:{}, //复合视图对象
            customParamInfo:{}, //自定义组件的外部参数
            formParamObj:{}, // 系统参数
            groupFieldObj:{}, // 分组内容obj
            tabsFieldObj:{}, // 分组内容obj
            groupRefs:[],
            inGroupFieldIdArr:[], // 在分组内的控件
            inTabsFieldIdArr:[], // 在分组内的控件
            // printFormStyles:{
            //     //存放的是 动态修改的样式
            //     conFormStyle:"", //内容form总样式
            //     conTableStyle:"100%", //内容table总样式
            // },
            // isShowPrintStyle: false,
            fieldContent:{},
            fieldCupJointArr:{},
            cupJoinObj:{},
            userBackfillArr: [], //判断哪些组件是用户回填组件
            userBackfillKey: "",
            userBackfillDataId: "",
            randomId:"", // 后台生成的随机ID
            tempKey: '',
            sequnceNumber:{},
            viewTableFormLoadInfo:{},
            plMapModuleArr: [],
            skinType: "",
            skinBackground: "",
            notClear:true,
            fieldIdName:{}, // 表单字段id转字段名
            beforeLoadSuccessEvent: null, // 新版本渲染方法
        }
    },

    computed:{
        formalParams(){
            return [
                'formData',//行数据
                'CTX',
                'vm',
                'axios',
                'Ajax',
                'resolve'
                // 'eventListener'
            ];
        },

        argumens(){
            // const sopt = {
            //     'hideFields': this.hideFields,
            //     'hideTrsByField': this.hideTrsByField,
            //     'showTrsByField': this.showTrsByField
            // };
            return [
                this.optFormData, //行数据
                formEvent.CTX,
                this,
                formEvent.axios,
                AjaxUtil,
                null
                // this.eventListener
            ];
        },
    },

    methods:{
        async loadDecryptFormData() {
            if (!this.dataId) {
                return;
            }
            let url = this.api.plCommonmethod.getById;
            let param = {formId: this.formId, dataId: this.dataId, operate: 'update', listViewId: this.listViewId};
            let res = await this.spcpFormAxios.post(url, param);
            if (res && res.data && res.data.operateObj) {
                res.data.operateObj.forEach(obj => {
                    this.decryptFormData = {...this.decryptFormData, ...obj};
                });
            }
        },
        /**
         * 加载表单视图所有数据
         */
        loadData(){
            this.loadDataSuccess = false;
            return new Promise(resolve => {
                this.initData2().then(() => {
                    resolve && resolve();
                })
            })
        },

        /**
         * 优化并发方法（测试阶段-ZHOUWEI 20200819）
         */
        initData2(){
            this.operate = this.formOperate; // 转换状态

            if(this.isGroup || this.isTabs){
                this.optFormData = this.propFormData;
                this.dataAllObj = this.propDataAllObj;
                this.tableviewsData = this.propTableviewsData;
                this.formId = this.tableviewsData.formId;
                this.uploadFkInfo = this.propUploadFkInfo;
                this.tableviewEventArr = this.propTableviewEventArr;
                this.conditionEventRuleArr = this.propConditionEventRuleArr;
                this.newConditionEventRuleArr = this.propNewConditionEventRuleArr;
                this.controlEventObj = this.propControlEventObj;
                this.newControlEventObj = this.propNewControlEventObj;
                this.fieldSysDataObj = this.propFieldSysDataObj;
                this.addCommentsFields = this.propAddCommentsFields;
                this.relationId = this.propRelationId;
                return new Promise(resolve => {
                    this.FORM_GLOBAL.getFormBase(this.formId).then(formBaseData => {
                        this.formDefineKey = formBaseData.defineKey;
                        this.FORM_GLOBAL.getAllFormFields(this.formDefineKey).then(datas => {
                            (datas || []).forEach(item => {
                                this.fieldIdName[item.id] = item["phyfieldName"];
                                this.formFieldObj[item.id] = item;
                            })
                            resolve();
                        })
                    })
                })
            }

            return new Promise(resolve => {
                // 重置所有数据状态
                this.resetDataState();
                this.loadLoginUser();
                this.loadtableviewData2().then(() => {
                this.spcpFormAxios.all([
                    this.loadViewsEvent(),
                    this.loadTableViewsEvent2()
                ]).then(this.spcpFormAxios.spread(() => {
                    this.spcpFormAxios.all([
                        this.loadFormData2(),
                        this.loadFormRenderData2()
                    ]).then(this.spcpFormAxios.spread(async(data1, data2) => {
                        await this.fillInitData();
                        await this.getVisiableByCondition();
                        this.beforeLoadSuccessEvent && this.beforeLoadSuccessEvent();
                        this.$nextTick(() => {
                            // 加载表单视图脚本
                            if(this.tableviewsData.viewScript) {
                                this.loadScriptData().then(() => {//初始化加载脚本配置
                                    this.scriptDataArr.forEach(scriptData => { //多脚本顺序执行
                                        this.execBeforeScripts(scriptData, this.operate, 'Open'); //打开前执行脚本
                                    });
                                    this.scriptDataArr.forEach(scriptData => { //多脚本顺序执行
                                        this.execAfterScripts(scriptData, this.operate, 'Open');//打开后执行脚本
                                    });
                                });
                            }
                            if(this.formOperate == 'add'){//编辑列表回填参数
                                Object.keys(this.editParamObj).forEach(fieldId =>{
                                    this.$set(this.optFormData,fieldId,this.editParamObj[fieldId]);
                                });
                                // 编辑表单回填参数
                                Object.keys(this.parentOptTableData).forEach(field =>{
                                    this.$set(this.optFormData,field,this.parentOptTableData[field]);
                                });
                            }
                            this.initFormParam().then(() =>{
                                this.initCustom().then(() => {
                                    this.loadDataSuccess = true;
                                    resolve();
                                })
                            });
                        });
                    }));
                }))
                });
            });
        },

        initFormParam(){
            return new Promise(resolve => {
                this.FORM_GLOBAL.getFormParam().then(data => {
                    (data || []).forEach(item => {
                        this.formParamObj[item.paramKey] = item.paramVal;
                    })
                    resolve();
                })
            })
        },

        /**
         * 加载自定义组件
         */
        initCustom(){
            return new Promise(resolve => {
                this.FORM_GLOBAL.getCustomComp().then(datas => {
                    let result = datas || {};
                    if (Object.keys(result).length > 0) {
                        let box = document.head.getElementsByTagName("script");
                        let srcUrls = [];
                        if (box.length > 0) {
                            for (let i = 0; i < box.length; i++) {
                                if (
                                    box[i].getAttribute("cus-ass") &&
                                    box[i].getAttribute("cus-ass") == "cusAss"
                                ) {
                                    srcUrls.push(box[i].getAttribute("custom-id"));
                                }
                            }
                        }
                        let lengthAll = 0;
                        let countLoad = 0;
                        Object.keys(result).forEach(key => {
                            let item = result[key];
                            if(!item.config || !item.render){
                                return;
                            }

                            this.customParamInfo[item.render] = this.analyseParam(JSON.parse(item.paramSetting || "[]"));

                            let flag = true;
                            for (let j = 0; j < srcUrls.length; j++) {
                                if (srcUrls[j] == item.id) {
                                    flag = false;
                                }
                            }
                            if (flag) {
                                lengthAll++;
                                let script = document.createElement("script");
                                script.type = "text/javascript";
                                script.defer = true;
                                script.src = window.FORM_RENDER_URL + "/uploadFile/assembly/" + item.id + "/" + item.jsName; // /src/js/xxxx.js
                                script.setAttribute("cus-ass", "cusAss");
                                script.setAttribute("custom-id", "cusAss");
                                document.head.appendChild(script);
                                // 等待组件资源加载完毕,进行渲染自定义组件
                                if (script.readyState) { //IE兼容
                                    script.onreadystatechange = () => {
                                        if (
                                            script.readyState == "complete" ||
                                            script.readyState == "loaded"
                                        ) {
                                            script.onreadystatechange = null;
                                            resolve();
                                        }
                                    };
                                } else {
                                    script.onload = () => {
                                        countLoad++;
                                        if (countLoad == lengthAll) {
                                            resolve();
                                        }
                                    };
                                    script.onerror = () => {
                                        countLoad++;
                                        if (countLoad == lengthAll) {
                                            resolve();
                                        }
                                    };
                                }
                            }
                        })

                        if(lengthAll === 0){
                            resolve();
                        }
                    }else{
                        resolve();
                    }
                })
            })
        },

        /**
         * 解析外部参数
         */
        analyseParam(paramSetting){
            let obj = {};
            paramSetting.forEach(item => {
                if(item.paramValType == 'sysparam'){
                    obj[item.paramName] = this.formParamObj[item.value];
                }
                if(item.paramValType == 'constant'){
                    obj[item.paramName] = item.value;
                }
            })
            return obj;
        },

        loadtableviewData2() {
            return new Promise(resolve => {
                this.FORM_GLOBAL.getTableViews(this.tableviewId).then(tableviewsData => {
                    if(!tableviewsData || !tableviewsData.id){
                        this.$message.error("表单资源不存在！");
                        return;
                    }
                    this.tableviewsData = tableviewsData;
                    this.formId = this.tableviewsData.formId;
                    this.userBackfillKey = `userBackfill-${this.formId}-${this.tableviewId}`;
                    let objForm = {};
                    (this.tableviewsData.viewStyle || "").split(";").forEach(item => {
                        let tempArrForm = item.split(":");
                        if (tempArrForm.length == 2) {
                            objForm[tempArrForm[0]] = tempArrForm[1];
                        }
                    });
                    delete objForm["background-color"];
                    this.$set(this.tableviewsData, 'form-style', objForm);
                    this.FORM_GLOBAL.getFormBase(this.formId).then(formBaseData => {
                        this.formDefineKey = formBaseData.defineKey;
                        let sourceKey = formBaseData.sourceKey;
                        let shareSources = formBaseData.shareSources;
                        if((shareSources || "").indexOf(this.sourceId) > -1){
                            sourceKey = this.sourceId;
                        }else if(this.sourceId){
                            this.$message.error("无效的数据源ID，已自动调整为默认数据源！");
                        }
                        let currentSourceKey = window.currentDataSourceKey;
                        if(!currentSourceKey) {
                            window.currentDataSourceKey = sourceKey;
                        }
                        if(Object.keys(this.formFieldObj || {}).length > 0){
                            Object.keys(this.formFieldObj).forEach(key => {
                                this.fieldIdName[key] = this.formFieldObj[key]["phyfieldName"];
                            })
                            resolve();
                        }else{
                            this.FORM_GLOBAL.getAllFormFields(this.formDefineKey).then(datas => {
                                (datas || []).forEach(item => {
                                    this.fieldIdName[item.id] = item["phyfieldName"];
                                    this.formFieldObj[item.id] = item;
                                })
                                resolve();
                            })
                        }
                    })
                });
            });
        },

        loadFormRenderData2() {
            return new Promise(resolve => {
                this.FORM_GLOBAL.getControlConfig(this.tableviewId,this.loginUser.userType).then(resData =>{
                    this.groupFieldObj = {};
                    this.tabsFieldObj = {};
                    this.inGroupFieldIdArr = [];
                    this.inTabsFieldIdArr = [];
                    (resData || []).forEach(item => {
                        if(typeof(item.specialSet) == 'string'){
                            item.specialSet = JSON.parse(item.specialSet || "{}");
                        }
                        let objTd = {};
                        (item.colCss || "").split(";").forEach(item => {
                            let tempArrTd = item.split(":");
                            if (tempArrTd.length === 2) {
                                objTd[tempArrTd[0]] = tempArrTd[1];
                            }
                        });
                        this.$set(item, 'td-style', objTd);
                        Object.keys(item.specialSet).forEach(key => {
                            if (Object.keys(item).indexOf(key) == -1) {
                                item[key] = item.specialSet[key];
                            }
                        });
                        if (item.controlType === "editList") {
                            this.editTableFormId.push(item.linkFormId);
                        }
                        if (item.isUserBackfill && item.isUserBackfill === "1"){
                            this.userBackfillArr.push(item);
                        }
                        if(item.groupField){
                            this.inGroupFieldIdArr.push(item.code);
                            if(!this.groupFieldObj[item.groupField]){
                                this.groupFieldObj[item.groupField] = [];
                            }
                            this.groupFieldObj[item.groupField].push(item);
                        }
                        if(item.tabsField){
                            this.inTabsFieldIdArr.push(item.code);
                            if(!this.tabsFieldObj[item.tabsField]){
                                this.tabsFieldObj[item.tabsField] = [];
                            }
                            this.tabsFieldObj[item.tabsField].push(item);
                        }
                        if (item.controlType === 'mapManagement' || item.controlType === 'regionalContour') {
                            this.plMapModuleArr.push(item);
                        }
                    });
                    this.contentArr = resData || [];
                    let result = new commonRender().renderTrs(this.contentArr,'pc',this.inGroupFieldIdArr,this.operate,this.inTabsFieldIdArr);
                    this.renderArr = result[0];
                    this.dataAllObj = result[1];
                    this.oldDataAllObj = JSON.parse(JSON.stringify(this.dataAllObj)); //拷贝一份
                    //初始化验证
                    if (this.operate !== 'view'){
                        // (this.renderArr || []).forEach((tr, trIndex) => {
                        //     (tr["tds"] || []).forEach((td, tdIndex) => {
                        //         this.buidRules(td, trIndex, tdIndex);
                        //     });
                        // });
                        if(this.isGroup){
                            (this.groupArr || []).forEach((tr,trIndex) =>{
                                (tr["tds"] || []).forEach((td,tdIndex) =>{
                                    this.buidRules(td,trIndex,tdIndex);
                                });
                            });
                        }else if(this.isTabs){
                            (this.tabsArr || []).forEach((tr,trIndex) =>{
                                (tr["tds"] || []).forEach((td,tdIndex) =>{
                                    this.buidRules(td,trIndex,tdIndex);
                                });
                            });
                        }else{
                            (this.renderArr || []).forEach((tr,trIndex) =>{
                                (tr["tds"] || []).forEach((td,tdIndex) =>{
                                    this.buidRules(td,trIndex,tdIndex);
                                });
                            });
                        }
                    }
                    resolve();
                });
            });
        },

        loadFormData2() {
            return new Promise(resolve => {
                if (!this.dataId) {
                    if(this.addDataId){
                        this.randomId = this.addDataId;
                        resolve();
                        return;
                    }
                    this.spcpFormAxios.post(this.api.plCommonmethod.getRandomId, {formId:this.formId}).then(res => {
                        this.randomId = res.data + '';
                        resolve();
                    });
                    return;
                }
                let url = this.isSignForm ? this.api.plCommonmethod.getSignFormById : this.api.plCommonmethod.getById;
                let param = {formId: this.formId, dataId: this.dataId,operate:this.formOperate};
                if (!this.isSignForm) {
                    param = Object.assign({listViewId: this.listViewId}, param);
                }
                this.spcpFormAxios.post(url, param).then(res => {
                    if (res && res.data && res.data.operateObj) {
                        res.data.operateObj.forEach(obj => {
                            this.initFormData = {...this.initFormData, ...obj};
                        });
                    }
                    resolve();
                });
            });
        },

        loadTableViewsEvent2(){
            return new Promise(resolve => {
                let vm = this;
                vm.tableviewEventArr = [];
                this.FORM_GLOBAL.getEventRules(vm.tableviewsData.id,this.loginUser.userType).then(data => {
                    data.forEach(item => {
                        if(typeof item.fieldId == "string"){
                            item.fieldId = item.fieldId ? item.fieldId.split(";") : [];
                        }
                        item.conditionDetailArr = item.conditionSetList || [];
                        item.eventFieldDetailArr = item.controlSetList || [];
                    });
                    this.tableviewEventArr = data || [];
                    //加载事件规则
                    this.loadTableviewEvent();
                    resolve();
                });
            })
        },
        async fillInitData(){
            this.addCommentsFields = [];
            this.optFormData = JSON.parse(JSON.stringify(this.initFormData));
            if(this.isEditTableForm && this.isFirstClick) {
                this.optFormData = this.parentOptTableData;
            }
            if(this.isTempEdit && this.operate !== 'add') {
                let tempEditData = 'tempEdit_' + this.dataId;
                this.optFormData = this.parentOptFormData[tempEditData];
                return;
            }
            if(this.isCopyOperate && ((this.noCopyArr || []).length > 0)){
                this.noCopyArr.forEach(key => {
                    delete this.optFormData[key];
                })
            }
            let dataId = this.optFormData.ID || "";
            this.relationId = dataId + "" || this.randomId || this.COMMON_FUNC.getUuidByParams(32);
            if(this.operate == "add"){ //新增
                //先查表里是否有数据，有数据赋值
                let preJson = {};
                let userBackfillData = null;
                if (this.contentArr.some(item => item.isUserBackfill === "1")){
                    let userData = this.PUBLIC_CACHE_UTIL.DATA_OBJ['userBackfill'] || {};
                    if (userData.hasOwnProperty(this.userBackfillKey)){
                        // 有缓存直接取
                        userBackfillData = userData[this.userBackfillKey];
                        this.userBackfillDataId = userBackfillData.ID;
                    }else {
                        // 无缓存重新请求
                        userBackfillData = await this.getUserBackfillData();
                    }
                    if (userBackfillData){
                        preJson = JSON.parse(userBackfillData['PRE_JSON'] || "{}");
                    }
                    // console.log('userData',userData);
                }
                this.contentArr.forEach(item => {
                    let fieldId = item.fieldId;
                    //取出数据进行表单操作数据赋值
                    if (Object.keys(preJson).includes(fieldId) && item.isUserBackfill === "1" && fieldId.split(",").length <= 1){
                        this.$set(this.optFormData, fieldId, preJson[fieldId] || "");
                    }
                    switch (item.controlType){
                        case "input":
                        case "textarea":
                        case "password":
                            if(this.isFlow && this.flowFieldStatus[fieldId]!="edit"){ // 工作流不可編輯字段初始化不賦默認值
                                return;
                            }
                            if(item.defaultVal){
                                if(item.defaultVal == "diy"){
                                    let defaultValText = item.defaultValText || "";
                                    if((defaultValText || "").toLowerCase().indexOf('loginuser') > -1){
                                        defaultValText = Replace.text(this.loginUser,defaultValText);
                                    }
                                    if((defaultValText || "").toLowerCase().indexOf('logindept') > -1){
                                        defaultValText = Replace.text(this.userDept,defaultValText);
                                    }
                                    if(defaultValText.indexOf("${user.") > -1){
                                        let textArr = defaultValText.split("${user.");
                                        (textArr || []).forEach(item => {
                                            if(item.indexOf("}") > -1){
                                                let key = item.substring(0,item.length - 1);
                                                let cacheObj = this.CACHE_GLOBAL.getLocalJSON("LOGINUSER") || {};
                                                let value = cacheObj[key] || "";
                                                defaultValText = this.platStringUtil.replaceAll(defaultValText,"${user." + key + "}",value);
                                            }
                                        })
                                    }
                                    if(defaultValText.indexOf("${USER_GLOBAL.") > -1){
                                        let textArr = defaultValText.split("${USER_GLOBAL.");
                                        textArr.forEach(text => {
                                            if(text.indexOf("}") > -1){
                                                let key = text.substring(0,text.length - 1);
                                                let value = this.CACHE_GLOBAL.getLocalJSON(key);
                                                if(key.indexOf(".") > -1){
                                                    let cacheObj = this.CACHE_GLOBAL.getLocalJSON(key.split(".")[0]) || {};
                                                    value = cacheObj[key.split(".")[1]];
                                                }
                                                defaultValText = this.platStringUtil.replaceAll(defaultValText,"${USER_GLOBAL." + key + "}",value);
                                            }
                                        });
                                    }
                                    if(defaultValText.indexOf("${listOutParam.") > -1){
                                        defaultValText = defaultValText.replace("${listOutParam.",""); // 去除${listOutParam.
                                        defaultValText = defaultValText.substring(0,defaultValText.length - 1); // 去除}
                                        defaultValText = (this.listOutParam || {})[defaultValText] || "";
                                    } else if(defaultValText.indexOf("${outParam.") > -1){
                                        defaultValText = defaultValText.replace("${outParam.",""); // 去除${outParam.
                                        defaultValText = defaultValText.substring(0,defaultValText.length - 1); // 去除}
                                        defaultValText = (this.outParam || {})[defaultValText] || "";
                                    }
                                    this.$set(this.optFormData,fieldId,defaultValText);

                                }else if(item.defaultVal.indexOf('SYSTIME.time') > -1){
                                    this.$set(this.optFormData, fieldId, this.viewDateFormat(new Date(),'yyyy-MM-dd HH:mm:ss'));
                                }else if((item.defaultVal || "").toLowerCase().indexOf('loginuser') > -1){ //用户信息
                                    this.$set(this.optFormData,fieldId,Replace.text(this.loginUser,item.defaultVal));
                                }else if(item.defaultVal.indexOf('loginDept') > -1){ //部门
                                    this.$set(this.optFormData,fieldId,Replace.text(this.userDept,item.defaultVal));
                                }
                            }
                            break;
                        case "currency":
                            if(this.isFlow && this.flowFieldStatus[fieldId]!="edit"){ // 工作流不可編輯字段初始化不賦默認值
                                return;
                            }
                            if(item.defaultVal){
                                this.$set(this.optFormData, fieldId, item.defaultVal);
                            }
                            break;
                        case "select":
                            if(this.isFlow && this.flowFieldStatus[fieldId]!="edit"){ // 工作流不可編輯字段初始化不賦默認值
                                return;
                            }
                            if(item.muliti == "true"){
                                if(item.spdefaultVal && typeof (item.spdefaultVal) == 'string'){
                                    this.$set(this.optFormData, fieldId, item.spdefaultVal.split(","));
                                }else if(item.spdefaultVal && typeof (item.spdefaultVal) == 'object'){
                                    this.$set(this.optFormData, fieldId, JSON.parse(JSON.stringify(item.spdefaultVal)));
                                }else{
                                    this.$set(this.optFormData,fieldId,[]);
                                }
                                if (item.isUserBackfill === "1" && item.spdefaultVal.length == 0){
                                    this.$set(this.optFormData, fieldId, preJson[fieldId] || []);
                                }
                            }else{
                                if (item.spdefaultVal){
                                    this.$set(this.optFormData,fieldId,item.spdefaultVal || "");
                                }else {
                                    if (item.isUserBackfill === "1"){
                                        this.$set(this.optFormData, fieldId, preJson[fieldId] || "");
                                    }
                                }
                            }
                            break;
                        case "cascadeSelect":
                            if (item.isUserBackfill === "1"){
                                fieldId.split(",").forEach(key => {
                                    this.$set(this.optFormData, key, preJson[key]);
                                })
                            }
                            break;
                        case "cascadeSelectOne":
                            if (item.isUserBackfill === "1") {
                                this.$set(this.optFormData, fieldId, preJson[fieldId] || "");
                            }
                            if (item.defaultValue && item.defaultValue.length > 0) {
                                this.$set(this.optFormData, fieldId, item.defaultValue.join(","));
                            }
                            break;
                        case "userSelect":
                            if(item.selectType == "userTree" && item.spdefaultVal =='loginUser'){//当前用户
                                if(item.muliti == "true"){//多选
                                    if(item.saveType=='dataId'){//关联标识
                                        this.$set(this.optFormData, fieldId, [this.loginUser.id]);
                                    }else{
                                        this.$set(this.optFormData, fieldId, [this.loginUser.userName]);
                                    }
                                }else{
                                    if(item.saveType=='dataId'){//关联标识
                                        this.$set(this.optFormData, fieldId, this.loginUser.id);
                                    }else{
                                        this.$set(this.optFormData, fieldId, this.loginUser.userName);
                                    }
                                }
                            }
                            break;
                        case "radio":
                            if(this.isFlow && this.flowFieldStatus[fieldId]!="edit"){ // 工作流不可編輯字段初始化不賦默認值
                                return;
                            }
                            if (item.spdefaultVal){
                                this.$set(this.optFormData,fieldId,item.spdefaultVal || "");
                            }else {
                                if (item.isUserBackfill === "1"){
                                    this.$set(this.optFormData, fieldId, preJson[fieldId] || "");
                                }
                            }
                            break;
                        case "checkbox":
                            if(this.isFlow && this.flowFieldStatus[fieldId] !== "edit"){ // 工作流不可編輯字段初始化不賦默認值
                                return;
                            }
                            let spDefaultVal = [];
                            if(item && item.spdefaultVal){
                                spDefaultVal = JSON.parse(JSON.stringify(item.spdefaultVal)) || [];
                            }
                            // this.$set(this.optFormData,fieldId,(spDefaultVal.length > 0) ? spDefaultVal : JSON.parse(JSON.stringify([])));
                            if (spDefaultVal.length > 0){
                                this.$set(this.optFormData, fieldId, spDefaultVal);
                            }else {
                                if (item.isUserBackfill === "1"){
                                    this.$set(this.optFormData, fieldId, preJson[fieldId] || []);
                                }else {
                                    this.$set(this.optFormData, fieldId, JSON.parse(JSON.stringify([])));
                                }
                            }
                            break;
                        case "time":
                            if(this.isFlow && this.flowFieldStatus[fieldId]!="edit"){ // 工作流不可編輯字段初始化不賦默認值
                                return;
                            }
                            this.$set(this.optFormData,fieldId,"");
                            if (item.defaultValueType){
                                if(item.defaultValueType == '系统时间'){
                                    this.optFormData[fieldId] = this.viewDateFormat(new Date(),item.displayFormatter || 'yyyy-MM-dd');
                                }else if(item.defaultValueType == '向前数月'){
                                    this.optFormData[fieldId] = this.getPreOrNextMonth('pre',item.defaultBeforeMonth,item.displayFormatter || 'yyyy-MM-dd');
                                }else if(item.defaultValueType == '向后数月'){
                                    this.optFormData[fieldId] = this.getPreOrNextMonth('next',item.defaultAfterMonth,item.displayFormatter || 'yyyy-MM-dd');
                                }else if(item.diyDefaultVal){
                                    this.optFormData[fieldId] = item.diyDefaultVal;
                                }
                            }else {
                                if (item.isUserBackfill === "1"){
                                    this.optFormData[fieldId] = preJson[fieldId] || "";
                                }
                            }
                            break;
                        case "enclosure": // 添加时生成附件fkId信息
                            let hasEnclosureIdentification = item.enclosureIdentification?item.enclosureIdentification:fieldId;
                            this.uploadFkInfo[fieldId] = this.relationId +"_"+ hasEnclosureIdentification;
                            break;
                        case "enclosureView":
                            this.uploadFkInfo[fieldId] =  this.relationId +"_"+ item.linkFieldId;
                            break;
                        case "pictureSet": //图片
                            this.uploadFkInfo[fieldId] = this.relationId +"_"+ fieldId;
                            break;
                        case "contactParty": //联系方
                            break;
                        case "addComments": //追加意见
                            if(!this.optFormData[fieldId]){
                                this.$set(this.optFormData,fieldId,this.COMMON_FUNC.getUuidByParams(32));
                            }
                            this.addCommentsFields.push(fieldId);
                            break;
                        case "switchButton":
                            if(item.defaultType =='true' &&!this.optFormData[fieldId+"_useDefault"]){
                                //开关组件设置了默认打开时,手动拼一个字段用来存储是否启用成功
                                this.$set(this.optFormData,fieldId,item.activeValue);
                                this.$set(this.optFormData,fieldId+"_useDefault","1");
                            }
                            break;
                        default:
                            if(this.listOutParam[fieldId]){
                                this.$set(this.optFormData,fieldId,this.listOutParam[fieldId]);
                            }
                            break;
                    }
                })
                if (this.userBackfillArr.length > 0 && this.userBackfillArr.some(item => item.controlType === "cascadeSelect")){
                    let msg = this.COMMON_FUNC.getUuidByParams(32);
                    this.$set(this.optFormData,'refreshUUId',msg);
                }
            }else{ // 修改或查看
                this.contentArr.forEach(item => {
                    let fieldId = item.fieldId;
                    // 处理旧数据中的combo:
                    if(this.optFormData[fieldId] && typeof this.optFormData[fieldId] =='string' && this.optFormData[fieldId].indexOf("combo:") > -1){
                        let valArr = this.optFormData[fieldId].split(":");
                        if(valArr.length == 3){
                            delete this.optFormData[fieldId];
                            this.$set(this.optFormData, fieldId, valArr[2]);
                        }
                    }
                    switch (item.controlType){
                        case "select":
                            if(this.isFlow) { // 工作流不可編輯字段初始化不賦默認值
                                if (this.flowFieldStatus[fieldId] != "edit") {
                                    return;
                                } else {
                                    if (this.optFormData[fieldId] && item.muliti == "true") {
                                        this.$set(this.optFormData, fieldId, this.optFormData[fieldId].split(","));
                                    }
                                    if(this.operate == "view"){ // 查看不赋默认值
                                        break;
                                    }
                                    if ((!this.optFormData[fieldId]) && item.spdefaultVal) {
                                        if (item.muliti == "true" && typeof (item.spdefaultVal) == 'string') {
                                            this.$set(this.optFormData, fieldId, item.spdefaultVal.split(","));
                                        } else {
                                            this.$set(this.optFormData, fieldId, item.spdefaultVal);
                                        }
                                    }
                                }
                            }else{
                                if (this.optFormData[fieldId] && item.muliti == "true") {
                                    this.$set(this.optFormData, fieldId, this.optFormData[fieldId].split(","));
                                }
                            }
                            break;
                        case "checkbox":
                            if(this.isFlow) { // 工作流不可編輯字段初始化不賦默認值
                                if (this.flowFieldStatus[fieldId] != "edit") {
                                    return;
                                } else {
                                    if (this.optFormData[fieldId]) {
                                        this.$set(this.optFormData, fieldId, this.optFormData[fieldId].split(","));
                                    } else {
                                        if(this.operate == "view"){ // 查看不赋默认值
                                            break;
                                        }
                                        if (item.spdefaultVal) {
                                            let spdefaultVal = JSON.parse(JSON.stringify(item.spdefaultVal)) || [];
                                            this.$set(this.optFormData, fieldId, spdefaultVal);
                                        } else {
                                            this.$set(this.optFormData, fieldId, []);
                                        }
                                    }
                                }
                            }else{
                                if(this.optFormData[fieldId]){
                                    this.$set(this.optFormData,fieldId,this.optFormData[fieldId].split(","));
                                }else{
                                    this.$set(this.optFormData,fieldId,[]);
                                }
                            }
                            break;
                        case "input":
                        case "textarea":
                        case "password":
                            if(this.isFlow) { // 工作流不可編輯字段初始化不賦默認值
                                if (this.operate == "view" || this.flowFieldStatus[fieldId] != "edit") {
                                    return;
                                } else {
                                    if ((!this.optFormData[fieldId]) && item.defaultVal) {
                                        if (item.defaultVal == "diy") {
                                            let defaultValText = item.defaultValText;
                                            if ((defaultValText || "").toLowerCase().indexOf('loginuser') > -1) {
                                                defaultValText = Replace.text(this.loginUser, defaultValText);
                                            }
                                            if ((defaultValText || "").toLowerCase().indexOf('logindept') > -1) {
                                                defaultValText = Replace.text(this.userDept, defaultValText);
                                            }
                                            let textArr = defaultValText.split("${USER_GLOBAL.");
                                            textArr.forEach(text => {
                                                if (text.indexOf("}") > -1) {
                                                    let key = text.substring(0, text.length - 1);
                                                    let value = this.CACHE_GLOBAL.getLocalJSON(key);
                                                    if (key.indexOf(".") > -1) {
                                                        let cacheObj = this.CACHE_GLOBAL.getLocalJSON(key.split(".")[0]) || {};
                                                        value = cacheObj[key.split(".")[1]];
                                                    }
                                                    defaultValText = this.platStringUtil.replaceAll(defaultValText, "${USER_GLOBAL." + key + "}", value);
                                                }
                                            });
                                            this.$set(this.optFormData, fieldId, defaultValText);
                                        } else if (item.defaultVal.indexOf('SYSTIME.time') > -1) {
                                            this.$set(this.optFormData, fieldId, this.viewDateFormat(new Date(), 'yyyy-MM-dd HH:mm:ss'));
                                        } else if ((item.defaultVal || "").toLowerCase().indexOf('loginuser') > -1) { //用户信息
                                            this.$set(this.optFormData, fieldId, Replace.text(this.loginUser, item.defaultVal));
                                        } else if (item.defaultVal.indexOf('loginDept') > -1) { //部门
                                            this.$set(this.optFormData, fieldId, Replace.text(this.userDept, item.defaultVal));
                                        }
                                    }
                                }
                            }
                            break;
                        case "radio":
                            if(this.isFlow) { // 工作流不可編輯字段初始化不賦默認值
                                if (this.operate == "view" || this.flowFieldStatus[fieldId] != "edit") {
                                    return;
                                } else {
                                    if (!this.optFormData[fieldId]) {
                                        this.$set(this.optFormData, fieldId, item.spdefaultVal || "");
                                    }
                                }
                            }
                            break;
                        case "time":
                            if(this.isFlow){ // 工作流不可編輯字段初始化不賦默認值
                                if(this.operate == "view" || this.flowFieldStatus[fieldId]!="edit"){
                                    return;
                                }else{
                                    if(!this.optFormData[fieldId]){
                                        if(item.defaultValueType == '系统时间'){
                                            this.optFormData[fieldId] = this.viewDateFormat(new Date(),item.displayFormatter || 'yyyy-MM-dd');
                                        }else if(item.defaultValueType == '向前数月'){
                                            this.optFormData[fieldId] = this.getPreOrNextMonth('pre',item.defaultBeforeMonth,item.displayFormatter || 'yyyy-MM-dd');
                                        }else if(item.defaultValueType == '向后数月'){
                                            this.optFormData[fieldId] = this.getPreOrNextMonth('next',item.defaultAfterMonth,item.displayFormatter || 'yyyy-MM-dd');
                                        }else if(item.diyDefaultVal){
                                            this.optFormData[fieldId] = item.diyDefaultVal;
                                        }
                                    }
                                }
                            }
                            break;
                        case "enclosure": // 添加时生成附件fkId信息
                            let hasEnclosureIdentification = item.enclosureIdentification?item.enclosureIdentification:fieldId;
                            this.uploadFkInfo[fieldId] = this.relationId + "_" + hasEnclosureIdentification;
                            break;
                        case "enclosureView":
                            this.uploadFkInfo[fieldId] = this.relationId + "_" + item.linkFieldId;
                            break;
                        case "pictureSet": //图片
                            this.uploadFkInfo[fieldId] = this.relationId + "_" + fieldId;
                            break;
                        case "addComments":
                            if(!this.optFormData[fieldId]){
                                this.$set(this.optFormData,fieldId,this.COMMON_FUNC.getUuidByParams(32));
                            }
                            this.addCommentsFields.push(fieldId);
                            break;
                        default:
                            break;
                    }
                });
            }

            //工作流里配置的字段默认值
            if(this.isFlow){
                //处理默认值需要根据表单字段确定的
                Object.keys(this.flowFieldDefaultFromForm).forEach(fieldId => {
                    let fieldObj = this.flowFieldDefaultFromForm[fieldId] || {};
                    if(fieldObj.defaultValType == "dateTime" && fieldObj.dateTimeType == "formField"){
                        let time = "";
                        let formFieldId = fieldObj.formFieldId;
                        if(!this.optFormData[formFieldId]){
                            return;
                        }
                        let dateTimeFormat = fieldObj.dateTimeFormat || "yyyy-MM-dd";
                        let specialDate = fieldObj.specialDate;
                        let specialOpt = fieldObj.specialOpt;
                        let specialVal = fieldObj.specialVal;
                        if(specialDate && specialOpt && specialVal){
                            let date = new Date(this.optFormData[formFieldId]);
                            time = this.DATE_UTIL.timeConversion(date,dateTimeFormat,specialDate,specialOpt,specialVal);
                        }
                        this.flowFieldDefault[fieldId] = time;
                    }
                });
                //确定默认值
                Object.keys(this.flowFieldDefault).forEach(fieldId => {
                    let changeNum = this.flowFieldDefaultChangeNum[fieldId] || 1;
                    // let isEqDefault = (this.flowFieldDefault[fieldId] == this.optFormData[fieldId]);
                    if(this.optFormData[fieldId] && changeNum == 1){
                        return;
                    }
                    if(this.flowFieldStatus[fieldId] == "edit"){
                        let defaultVal = this.flowFieldDefault[fieldId];
                        if((defaultVal || "").indexOf("&&,") > -1 && (defaultVal || "").indexOf(",&&") > -1){
                            let fillfieldId = defaultVal.split(',')[1];
                            defaultVal = this.optFormData[fillfieldId];
                        }
                        this.$set(this.optFormData,fieldId,defaultVal);
                    }
                });
            }
        },
        /**
         * 加载表单视图事件
         */
        async loadViewsEvent(){
            let vm = this;
            vm.viewsEventMap = {};
            let data = await vm.FORM_GLOBAL.getEventSetsAsync(vm.formId,vm.tableviewsData.id,"basic");
            let serviceName = (window.SERVICE_NAME || {});
            let adminServeName = serviceName.admin || "/admin/";
            let formServeName = serviceName.form || "/form/";
            let flowServeName = serviceName.flow || "/flow/";
            let oaServeName = serviceName.oa || "/oaproject/";
            data.forEach(item =>{
                if(!vm.viewsEventMap[item.field]){
                    vm.$set(vm.viewsEventMap, item.field, {});
                }
                if(item.eventContent){
                    let value = item.eventContent;
                    // value = vm.platStringUtil.replaceAll(value,"/admin/",adminServeName);
                    // value = vm.platStringUtil.replaceAll(value,"/form/",formServeName);
                    // value = vm.platStringUtil.replaceAll(value,"/flow/",flowServeName);
                    // value = vm.platStringUtil.replaceAll(value,"/oaproject/",oaServeName);
                    // value = vm.platStringUtil.replaceAll(value,"/oaadmin/",adminServeName);
                    // value = vm.platStringUtil.replaceAll(value,"/oaform/",formServeName);
                    // value = vm.platStringUtil.replaceAll(value,"/oaflow/",flowServeName);
                    if(window.ADMIN_URL && (value.indexOf("/admin/") > -1 || value.indexOf("/oaadmin/") > -1)){
                        if(value.indexOf("/admin/")  > -1){
                            value = this.platStringUtil.replaceAll(value,"/admin/", window.ADMIN_URL + "/");
                        }else{
                            value = this.platStringUtil.replaceAll(value,"/oaadmin/",window.ADMIN_URL + "/");
                        }
                    }
                    if(window.FLOW_URL && (value.indexOf("/flow/") > -1 || value.indexOf("/oaflow/") > -1)){
                        if(value.indexOf("/flow/")  > -1){
                            value = this.platStringUtil.replaceAll(value,"/flow/", window.FLOW_URL + "/");
                        }else{
                            value = this.platStringUtil.replaceAll(value,"/oaflow/",window.FLOW_URL + "/");
                        }
                    }
                    if(window.FORM_RENDER_URL && (value.indexOf("/form/")  > -1|| value.indexOf("/oaform/") > -1)){
                        if(value.indexOf("/form/")  > -1){
                            value = this.platStringUtil.replaceAll(value,"/form/", window.FORM_RENDER_URL + "/");
                        }else{
                            value = this.platStringUtil.replaceAll(value,"/oaform/",window.FORM_RENDER_URL + "/");
                        }
                    }
                    if(window.OA_URL && (value.indexOf("/project/") > -1 || value.indexOf("/oaproject/") > -1)){
                        if(value.indexOf("/project/")  > -1){
                            value = this.platStringUtil.replaceAll(value,"/project/", window.OA_URL + "/");
                        }else{
                            value = this.platStringUtil.replaceAll(value,"/oaproject/",window.OA_URL + "/");
                        }
                    }
                    value = this.platStringUtil.replaceAll(value,"window.JAVA_URL","''");
                    value = this.platStringUtil.replaceAll(value,"JAVA_URL","''");
                    value = this.platStringUtil.replaceAll(value,"window.baseUrl","''");
                    value = this.platStringUtil.replaceAll(value,"baseUrl","''");
                    value = this.replaceFieldName(value);

                    item.eventContent = value;
                }
                vm.$set(vm.viewsEventMap[item.field], item.eventType, new Function(...vm.formalParams, item.eventContent));
            });
        },

        /**
         * 加载表单视图事件名称
         */
        async loadTableViewsEvent(){
            let vm = this;
            vm.tableviewEventArr = [];

            let data = await this.FORM_GLOBAL.getEventRulesAsync(vm.tableviewsData.id);
            data.forEach(item => {
                if(typeof item.fieldId == "string"){
                    item.fieldId = item.fieldId ? item.fieldId.split(";") : [];
                }
                item.conditionDetailArr = item.conditionSetList || [];
                item.eventFieldDetailArr = item.controlSetList || [];
            });
            this.tableviewEventArr = data || [];
            //加载事件规则
            this.loadTableviewEvent();

            /*let res = await this.spcpFormAxios.post(this.api.plTableviewsEvent.findEventRule, {tableViewId:vm.tableviewsData.id});
                if(res && res.data && res.data.operateObj){
                    (res.data.operateObj || []).forEach(item => {
                        item.fieldId = item.fieldId ? item.fieldId.split(";") : [];
                        item.conditionDetailArr = item.conditionSetList || [];
                        item.eventFieldDetailArr = item.controlSetList || [];
                    });
                    this.tableviewEventArr = res.data.operateObj || [];
                }
                //加载事件规则
                this.loadTableviewEvent();*/

        },

        /**
         * 加载脚本数据
         *  scriptUseType 使用方式
         * scriptPosition 脚本执行位置
         * scriptContent 函数内容
         */
        async loadScriptData(){
            const vm = this;
            vm.scriptDataArr = []; //脚本arr
            // 获取脚本
            let scriptsRes = await vm.FORM_GLOBAL.getFormScripts(vm.tableviewsData.viewScript);
            const scripts = scriptsRes || [];
            if(!!scripts && !!scripts && scripts.constructor === Array && scripts.length > 0) {
                let serviceName = (window.SERVICE_NAME || {});
                let adminServeName = serviceName.admin || "/admin/";
                let formServeName = serviceName.form || "/form/";
                let flowServeName = serviceName.flow || "/flow/";
                let oaServeName = serviceName.oa || "/oaproject/";
                scripts.forEach(script => {
                    if(!!script){
                        vm.clearScriptData(); //初始化scriptData对象
                        if(script.scriptContent){
                            let value = script.scriptContent;
                            // value = vm.platStringUtil.replaceAll(value,"/admin/",adminServeName);
                            // value = vm.platStringUtil.replaceAll(value,"/form/",formServeName);
                            // value = vm.platStringUtil.replaceAll(value,"/flow/",flowServeName);
                            // value = vm.platStringUtil.replaceAll(value,"/oaproject/",oaServeName);
                            // value = vm.platStringUtil.replaceAll(value,"/oaadmin/",adminServeName);
                            // value = vm.platStringUtil.replaceAll(value,"/oaform/",formServeName);
                            // value = vm.platStringUtil.replaceAll(value,"/oaflow/",flowServeName);
                            if(window.ADMIN_URL && (value.indexOf("/admin/") > -1 || value.indexOf("/oaadmin/") > -1)){
                                if(value.indexOf("/admin/")  > -1){
                                    value = this.platStringUtil.replaceAll(value,"/admin/", window.ADMIN_URL + "/");
                                }else{
                                    value = this.platStringUtil.replaceAll(value,"/oaadmin/",window.ADMIN_URL + "/");
                                }
                            }
                            if(window.FLOW_URL && (value.indexOf("/flow/") > -1 || value.indexOf("/oaflow/") > -1)){
                                if(value.indexOf("/flow/")  > -1){
                                    value = this.platStringUtil.replaceAll(value,"/flow/", window.FLOW_URL + "/");
                                }else{
                                    value = this.platStringUtil.replaceAll(value,"/oaflow/",window.FLOW_URL + "/");
                                }
                            }
                            if(window.FORM_RENDER_URL && (value.indexOf("/form/")  > -1|| value.indexOf("/oaform/") > -1)){
                                if(value.indexOf("/form/")  > -1){
                                    value = this.platStringUtil.replaceAll(value,"/form/", window.FORM_RENDER_URL + "/");
                                }else{
                                    value = this.platStringUtil.replaceAll(value,"/oaform/",window.FORM_RENDER_URL + "/");
                                }
                            }
                            if(window.OA_URL && (value.indexOf("/project/") > -1 || value.indexOf("/oaproject/") > -1)){
                                if(value.indexOf("/project/")  > -1){
                                    value = this.platStringUtil.replaceAll(value,"/project/", window.OA_URL + "/");
                                }else{
                                    value = this.platStringUtil.replaceAll(value,"/oaproject/",window.OA_URL + "/");
                                }
                            }
                            value = this.platStringUtil.replaceAll(value,"window.JAVA_URL","''");
                            value = this.platStringUtil.replaceAll(value,"JAVA_URL","''");
                            value = this.platStringUtil.replaceAll(value,"window.baseUrl","''");
                            value = this.platStringUtil.replaceAll(value,"baseUrl","''");
                            value = this.replaceFieldName(value);
                            script.scriptContent = value;
                        }
                        vm.scriptData[script.scriptUseType][script.scriptPosition] = new Function(...vm.formalParams, script.scriptContent);
                        vm.scriptDataArr.push(vm.scriptData);

                    }
                });
            }

        },

        replaceFieldName(value){
            // 替换表单字段为ID
            Object.keys(this.fieldIdName).forEach(fieldId => {
                let phyfieldName = this.fieldIdName[fieldId];
                value = this.platStringUtil.replaceAll(value,"${" + phyfieldName + "}",fieldId);
            })
            return value;
        },

        /**
         * 加载事件规则
         */
        loadTableviewEvent(){
            let vm = this;
            vm.newControlEventObj = {}; //新控件触发
            vm.newConditionEventRuleArr = []; //新条件触发

            vm.tableviewEventArr.forEach(item =>{
                if(item.affectContent && (typeof item.affectContent) == 'string'){ //影响内容
                    item.affectContent = JSON.parse(item.affectContent)|| {};
                }
                if(item.triggerType == "condition"){
                    if(!Number(item.isNewData)){
                        vm.conditionEventRuleArr.push(item); //老事件规则条件触发
                    }else if(item.isNewData == "1"){
                        vm.newConditionEventRuleArr.push(item);
                    }
                }
                //控件方式
                (item.eventFieldDetailArr ||[]).forEach(eventField =>{ //控件触发
                    if(!Number(item.isNewData)){ //老事件规则控件触发
                        if(!this.controlEventObj[eventField.field]){
                            this.$set(this.controlEventObj,eventField.field,{});
                        }
                        if(!this.controlEventObj[eventField.field][eventField.eventType]){
                            this.$set(this.controlEventObj[eventField.field],eventField.eventType,[]);
                        }
                        let arr = this.controlEventObj[eventField.field][eventField.eventType];
                        arr.push({fieldId:item.fieldId,eventType:item.eventType,affectContent:item.affectContent});
                    }else if(item.isNewData == '1' && item.triggerType == 'control'){ //新事件规则控件触发事件
                        if(!this.newControlEventObj[eventField.field]){
                            this.$set(this.newControlEventObj,eventField.field,{});
                        }
                        if(!this.newControlEventObj[eventField.field][eventField.eventType]){
                            this.$set(this.newControlEventObj[eventField.field],eventField.eventType,[]);
                        }
                        let arr = this.newControlEventObj[eventField.field][eventField.eventType];
                        arr.push(item.affectContent);//新响应规则
                    }
                });
            });
        },

        clearScriptData(){
            this.scriptData = {
                add: {beforeOpen: null, afterOpen: null},
                update: {beforeOpen: null, afterOpen: null},
                view: {beforeOpen: null, afterOpen: null},
                save: {beforeSubmit: null, afterSubmit: null},
                close: {beforeClose: null, afterClose: null},
                all: {beforeOpen: null, afterOpen: null, beforeSubmit: null, afterSubmit: null, beforeClose: null, afterClose: null}
            };
        },

        /**
         * 执行操作前脚本
         * scriptData 脚本数据
         * type 使用类型
         * operator 表单操作类型
         * argumens 脚本中的参数(以及系统方法)
         */
        execBeforeScripts(scriptData,type, operator){
            let retOp = null;
            let retAll = null;
            if(!!scriptData[type]['before'+operator] &&
                scriptData[type]['before'+operator].constructor === Function){
                retOp = scriptData[type]['before'+operator](...this.argumens);
            }
            if(!!scriptData['all']['before'+operator] &&
                scriptData['all']['before'+operator].constructor === Function){
                retAll = scriptData['all']['before'+operator](...this.argumens);
            }
            return {retOp, retAll};
        },

        /**
         * 执行操作后脚本
         * scriptData 脚本数据
         * type 使用类型
         * operator 表单操作类型
         * argumens 脚本中的参数(以及系统方法)
         */
        execAfterScripts(scriptData,type, operator){
            if(!!scriptData[type]['after'+operator] &&
                scriptData[type]['after'+operator].constructor === Function){
                scriptData[type]['after'+operator](...this.argumens);
            }
            if(!!scriptData['all']['after'+operator] &&
                scriptData['all']['after'+operator].constructor === Function){
                scriptData['all']['after'+operator](...this.argumens);
            }
        },

        async loadFormData(){
            if(!this.dataId){return;}
            let url = this.isSignForm ? this.api.plCommonmethod.getSignFormById : this.api.plCommonmethod.getById;
            let param = {formId:this.formId,dataId:this.dataId,operate:this.formOperate};
            if(!this.isSignForm){
                param = Object.assign({listViewId:this.listViewId},param);
            }
            let res = await this.spcpFormAxios.post(url, param);
            if(res && res.data && res.data.operateObj){
                res.data.operateObj.forEach(obj =>{
                    this.initFormData = { ...this.initFormData,...obj };
                });
            }
        },
        /**
         * 绑定el-form Rules 验证
         * @param obj
         * @param trIndex
         * @param tdIndex
         */
        buidRules(obj, trIndex, tdIndex) {
            let vm = this;
            let validFunArr = []; // 多个验证数组
            if(this.isFlow&&this.flowFieldStatus[obj.fieldId]!="edit"){
                return;
            }

            if(this.operate == 'view'){
                return;
            }

            if(obj.visible == 'false'){
                if(obj.fieldId){
                    delete this.rules[obj.fieldId];
                }
                return;
            }
            if(obj.editable != "false" && (obj.controlType == 'input' || obj.controlType == 'textarea')){
                let fieldInfo = this.formFieldObj[obj.fieldId] || {};
                if(fieldInfo.fieldLength && Number(fieldInfo.fieldLength) && fieldInfo.fieldType !== '7'){ // 超大文本不校验
                    const validOrFn = vm.platValidator["checkValueLength"].bind(null,fieldInfo.fieldLength);
                    validFunArr.push({validator:validOrFn,trigger: 'blur'});
                    // console.log(fieldInfo.chfieldName);
                    // if(fieldInfo.showName == '汇水面积(㎡)'){
                    //     console.log(validFunArr);
                    // }
                }
            }
            // if(obj.isRequired == "1" && obj.editable != "false"){
            vm.requiredStars[obj.fieldId]="";
            if(this.notClear){
                this.$refs.tableFormRef && this.$refs.tableFormRef.clearValidate();
            }

            if(obj.isRequired == "1" && obj.controlType != 'cascadeSelect'){
                vm.requiredStars[obj.fieldId] = '1';   //非空验证前加星星
                validFunArr.push({required: true, message: '必填'});
            }else if(obj.controlType == 'cascadeSelect'){
                let cascadeSetArr = obj.cascadeSetArr ||[];
                cascadeSetArr.some(cascade =>{
                    if(cascade.isNull == '1'){
                        vm.requiredStars[obj.fieldId] = '1';   //非空验证前加星星
                        validFunArr.push({required: true, message: '必填'});
                        return false;
                    }
                });
            }
            if(obj.validRules){
                let validFunChArr = obj.validRules.split(',') || [];
                let otherParam = {min:obj.minNumValue,max:obj.maxNumValue,regExp:obj["diyValidVal"]};
                const validOrFn = vm.platValidator["mulOrValidator"].bind(null,validFunChArr,otherParam);
                validFunArr.push({validator:validOrFn,trigger: 'blur'});
            }
            if(obj.controlType == 'input' || (obj.controlType == 'textarea'&&obj.editor != "true")||  obj.controlType == 'password'){
                if(this.operate == 'view'){
                    validFunArr.push({validator:vm.platValidator["isHaveHtmlExcludeDiv"],trigger: 'blur'});
                }else {
                    validFunArr.push({validator:vm.platValidator["isHaveHtml"],trigger: 'blur'});
                }
            }
            if(obj.controlType != "cascadeSelect"){
                let draftFuncArr = validFunArr.filter(item => {
                    return !item.required;
                })
                vm.$set(vm.draftRules, obj.fieldId, draftFuncArr);
                vm.$set(vm.rules, obj.fieldId, validFunArr);
            }
        },
        loadLoginUser(){
            this.loginUser = this.CACHE_GLOBAL.getLoginUser() || {};
            this.userDept = this.CACHE_GLOBAL.getLoginDept() || {};
        },
        resetDataState(){
            this.initFormData = {};
            this.optFormData = {};
            this.uploadFkInfo = {};
            this.rules = {};
            this.draftRules = {};
            this.tempRemoveUploadFile = [];
            this.userBackfillArr = [];
            this.userBackfillKey = "";
            this.userBackfillDataId = "";
            this.loadDataSuccess = false;
        },
        /**
         * 格式化日期type
         **/
        formatterDateType(displayFormatter){
            let type = "date";
            if(displayFormatter === 'yyyy-MM-dd'){
                type = 'date';
            }else if(displayFormatter === 'yyyy-MM-dd HH:mm:ss'){
                type = 'datetime';
            }else if(displayFormatter === 'yyyy'){
                type = 'year';
            }else if(displayFormatter === 'yyyy-MM'){
                type = 'month';
            }else{
                type = 'datetime';
            }
            return type;
        },

        setFormValue(a, b) {
            let vm = this;
            vm.$set(vm.optFormData, `${a}`, b);
        },

        /**
         * 时间格式化方法（查看表单视图时用到）
         * @param d
         * @param fmt
         * @return {string|void}
         */
        viewDateFormat(d, fmt) {
            if (d) {
                let date = new Date(d);
                let o = {
                    "M+": date.getMonth() + 1,                 //月份
                    "d+": date.getDate(),                    //日
                    "H+": date.getHours(),                   //小时
                    "m+": date.getMinutes(),                 //分
                    "s+": date.getSeconds(),                 //秒
                    "q+": Math.floor((date.getMonth() + 3) / 3), //季度
                    "S": date.getMilliseconds()             //毫秒
                };
                if (/(y+)/.test(fmt)) {
                    fmt = fmt.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));
                }
                for (let k in o) {
                    if (new RegExp("(" + k + ")").test(fmt)) {
                        fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
                    }
                }
            } else {
                fmt = '';
            }
            return fmt;
        },

        /**
         * 获取当前数月或者后数月
         */
        getPreOrNextMonth(type,monthNum,fmt){
            let date = new Date();
            let year = date.getFullYear();//年
            let month = date.getMonth()+1;//月
            let day = date.getDate(); //日
            let t2 = "";
            let monthNow = "";
            if(type == 'pre'){
                monthNow = month - parseInt(monthNum);
                if(monthNow >= 1 && monthNow <= 9){
                    monthNow = "0" + monthNow;
                }else if(monthNow <= 0){
                    monthNow =  12 + monthNow;
                    year = year - 1;
                }
            }else if(type == 'next'){
                monthNow = month + parseInt(monthNum);
                if(monthNow >= 1 && monthNow <= 9){
                    monthNow = "0" + monthNow;
                }else if(monthNow >= 12){
                    monthNow = monthNow - 12;
                    year = year + 1;
                }
            }
            if(day >=1 && day <= 9){
                day = "0" + day;
            }
            //获取目标月分的天数
            let tMonth = new Date(year,month,0);
            let tDay = tMonth.getDate();
            if(parseInt(day) > tDay){
                day = tDay;
            }
            t2 = year + '-' + monthNow + '-' + day;
            let houres = this.viewDateFormat(new Date(),'HH:mm:ss');
            t2 += " "+ houres;
            t2 = this.viewDateFormat(new Date(t2),fmt);
            return t2;
        },

        /**
         * 获取日期数组中的最小值
         * */

        getMinDateInMaxDateArr(maxTimeArr){
            let maxTime = '';
            if(maxTimeArr && maxTimeArr.length > 0){
                maxTime = maxTimeArr.reduce(function (a,b) {
                    return new Date(a).getTime() <= new Date(b).getTime() ? a:b;

                });
            }
            return maxTime;
        },

        getMaxDateInMinDateArr(minTimeArr){
            let minTime = '';
            if(minTimeArr && minTimeArr.length > 0){
                minTime =     minTimeArr.reduce(function (a,b) {
                    return   new Date(a).getTime() >= new Date(b).getTime() ? a:b;
                });
            }
            return minTime;
        },

        getTableStyle(){
            let tempStyle = {
                'width': '100%',
                'border-collapse': 'collapse',
                'margin':'auto',
                'border-left': (this.tableviewsData.viewBorder || '0') + 'px solid ' + (this.tableviewsData.viewBorderColor || '#c2c2c2'),
                'border-top': (this.tableviewsData.viewBorder || '0') + 'px solid ' + (this.tableviewsData.viewBorderColor || '#c2c2c2')
            };
            return Object.assign(tempStyle,{'width':this.tableviewsData.viewWidth},this.tableviewsData['form-style']);
        },

        changeField(field,result){
            this.$set(this.optFormData,field,result);
            this.$forceUpdate();
        },

        dealSubmitData(contentForm){
            for(let [key,value] of Object.entries(contentForm)){
                if(Array.isArray(value)){
                    let valueResult = "";
                    value.forEach(item => {
                        if(Array.isArray(item)){
                            valueResult += ";" + item.join(",");
                        }else{
                            valueResult += "," + item;
                        }
                    });
                    valueResult = valueResult.substring(1);
                    contentForm[key] = valueResult;
                }
                if(!value){
                    contentForm[key] = "";
                }
                let sequenceValue = contentForm[key + "_sequence"];
                if(sequenceValue){
                    contentForm[key] = JSON.parse(JSON.stringify(sequenceValue));
                    delete contentForm[key + "_sequence"];
                }
            }
            return contentForm;
        },

        /**
         * 校验数据是否可以存草稿
         */
        validateDraft(){
            this.$refs.tableFormRef.clearValidate();
            let validate = true;
            let tempRules = JSON.parse(JSON.stringify(this.rules));
            Object.assign(this.rules,this.draftRules);
            this.$refs.tableFormRef.validate(valid => {
                validate = valid;
            })
            this.$nextTick(() => {
                Object.assign(this.rules,tempRules);
            })
            return validate;
        },

        validateMethod(callBack){
            let result = true;
            this.$refs.tableFormRef.validate(valid => {
                result = valid;
            })
            if(this.validateGroup){
                let validGroupRes = this.validateGroup();
                if (!validGroupRes) {
                    result = false;
                }
            }
            callBack && callBack(result);
        },

        submitComment(){
            this.addCommentsFields.forEach(item=>{
                this.$refs[item] && this.$refs[item].onAddComment();
            });
        },

        /**
         * 表单保存数据
         * @param saveMessage 保存提示语
         * @returns {Promise<void>}
         */
        saveData(loginUserId,saveMessage,isEditTable,relationId, isTempEdit) {
            return new Promise(resolve => {
                this.notClear = false;
                this.$refs.tableFormRef.validate(valid => {
                    if(valid){
                        if(this.validateGroup){
                            let validGroupRes = this.validateGroup();
                            if(!validGroupRes){
                                resolve(false);
                                return;
                            }
                        }
                        let enclosureArr = [];
                        Object.values(this.dataAllObj).forEach(item => {
                            if(item.controlType == "enclosure"){
                                enclosureArr.push(item.fieldId);
                            }
                        });
                        Object.keys(this.optFormData).forEach(item => {
                            if(enclosureArr.indexOf(item) != -1){
                                this.optFormData[item] = "";
                            }
                        });
                        //执行提交前的代码
                        let scriptReult = true;
                        this.scriptDataArr.forEach(scriptData =>{ //提交前脚本执行
                            let result =  this.execBeforeScripts(scriptData, 'save', 'Submit'); //执行提交前脚本
                            if(!result.retOp){
                                scriptReult = true;
                            }else {
                                scriptReult = result.retOp;
                                if(result.retAll){
                                    scriptReult = scriptReult&&result.retAll;
                                }
                            }
                        });
                        Object.keys(this.optFormData).forEach(key => {
                            if(!this.optFormData[key]){
                                this.optFormData[key] = "";
                            }
                        })
                        //判断是否存在富文本编辑器的字段有的话把单引号转义
                        if(Object.keys(this.plUeditorObj).length>0){
                            Object.keys(this.optFormData).forEach(item =>{
                                if(this.plUeditorObj[item] && this.optFormData[item].includes("'")){
                                    let str=this.optFormData[item].split("'").join("\\'");
                                    this.$set(this.optFormData,item,str);
                                }
                            })
                        }
                        let contentForm = JSON.parse(JSON.stringify(this.optFormData));
                        contentForm = this.dealSubmitData(contentForm);
                        // 只拿当前表单数据, 防止大表里面有小表数据, 数据库保存失败
                        if(this.operate === 'update') {
                            let flag = false;
                            Object.values(this.dataAllObj).forEach(data => {
                                if(data.controlType === 'editTable') {
                                    flag = true;
                                }
                            })
                            if(flag) {
                                let editTableFields = [];
                                (Object.keys(contentForm) || []).forEach(item => {
                                    if(item.includes("editTable_")) {
                                        let field = item.substring(10);
                                        editTableFields.push(field);
                                        delete contentForm[item];
                                    }
                                })
                                Object.keys(contentForm).forEach(data => {
                                    if(editTableFields.includes(data)) {
                                        delete contentForm[data];
                                    }
                                })
                            }
                        }else {
                            (Object.keys(contentForm) || []).forEach(item => {
                                if(item.includes("editTable_")) {
                                    delete contentForm[item];
                                }
                            })
                        }
                        // console.log("contentForm = ", contentForm);
                        let paramObj = {};
                        let operate = "";
                        contentForm["UPDATED"] = loginUserId;
                        //如果时复制删除
                        if(this.isCopyOperate){
                            delete contentForm.ID;
                            delete contentForm["CREATE_TIME"];
                            delete contentForm["UPDATE_TIME"];
                            delete contentForm["STATUS"];
                            delete contentForm["CREATE_ORG"];
                            delete contentForm["CREATE_POS"];
                        }
                        if (this.operate !== "add" && contentForm.ID) {
                            delete contentForm["CREATE_TIME"];
                            delete contentForm["UPDATE_TIME"];
                            paramObj = {
                                formId: this.formId,
                                dataId: contentForm.ID,
                                updateParams: JSON.stringify(contentForm)
                            };
                            operate = "updateById"; //修改
                        } else {
                            if(isEditTable == "1"){
                                contentForm["RELATION_ID"] = relationId;
                                contentForm["ID"] = this.relationId;
                            }else if(isEditTable == "2"){
                                contentForm["RELATION_ID"] = relationId;
                                contentForm["ID"] = relationId;
                            } else{
                                contentForm["ID"] = this.relationId;
                            }
                            contentForm["CREATED"] = loginUserId;
                            paramObj = {formId: this.formId, params: JSON.stringify(contentForm)};
                            operate = "insert"; //新增
                        }
                        if(scriptReult){ //提交前脚本执行成功
                            //追加意见提交
                            this.addCommentsFields.forEach(item=>{
                                this.$refs[item] && this.$refs[item].onAddComment();
                            });
                            this.groupRefs.forEach(item => {
                                this.$refs[item] && this.$refs[item].submitComment();
                            })
                            // let tempKey = this.COMMON_FUNC.getUuidByParams(32);
                            if(isTempEdit && Object.keys(this.parentOptFormData).length > 0) {
                                let tempId = this.relationId || this.dataId;
                                this.$set(this.optFormData, 'ID', tempId);
                                this.$set(this.optFormData, 'formId', this.formId);
                                this.$set(this.optFormData, 'RELATION_ID', relationId);
                                this.$set(this.parentOptFormData, 'tempEdit_' + tempId, this.optFormData);
                                resolve(this.optFormData);
                                return;
                            }
                            // end
                            // console.log(JSON.stringify(contentForm),this.formId);
                            (Object.keys(this.optFormData) || []).forEach(item => {
                                if(item.indexOf('tempEdit_') > -1) {
                                    let tempObj = {};
                                    let tempOperate = "";
                                    if(this.operate === 'add') {
                                        tempOperate = "insert";
                                        tempObj = {formId: this.optFormData[item].formId, params:JSON.stringify(this.optFormData[item])};
                                    }else {
                                        if(this.optFormData[item]["CREATED"]) {
                                            tempOperate = "updateById";
                                            delete this.optFormData[item]["CREATE_TIME"];
                                            delete this.optFormData[item]["UPDATE_TIME"];
                                            tempObj = {
                                                formId: this.optFormData[item].formId,
                                                dataId: this.optFormData[item].ID,
                                                updateParams: JSON.stringify(this.optFormData[item])
                                            };
                                        }else {
                                            tempOperate = "insert";
                                            tempObj = {formId: this.optFormData[item].formId, params:JSON.stringify(this.optFormData[item])};
                                        }
                                    }
                                    this.spcpFormAxios.post(this.api.plCommonmethod.url + "/" + tempOperate, tempObj);
                                }
                            })
                            this.spcpFormAxios.post(this.api.plCommonmethod.url + "/" + operate, paramObj).then(res => {
                                if (res && res.data) {
                                    let type = "danger";
                                    let msg = "保存失败！";
                                    contentForm["flowSaveSuccess"] = true;
                                    if (res.data.operateSuccess) {
                                        type = "success";
                                        msg = "保存成功！";
                                        if(saveMessage){
                                            msg = saveMessage;
                                        }

                                        //删除附件
                                        if(this.tempRemoveUploadFile.length > 0){
                                            this.spcpFormAxios.post(this.api.baseUploadUrl + "delete", {"ids": this.tempRemoveUploadFile.join(",")});
                                        }

                                        let dataId = contentForm.ID || res.data.operateObj; // 修改时是有id的，添加时返回值有id
                                        if(!this.optFormData.ID){ // 添加后将Id置入
                                            this.optFormData.ID = dataId;
                                        }

                                        if (this.plMapModuleArr.length > 0) {
                                            let gisInfoArr = [];
                                            this.plMapModuleArr.forEach(item => {
                                                let fieldId = item.fieldId;
                                                let type = item.specialSet.type;
                                                let gisInfo = {};
                                                let ptNameFieldId = item.specialSet.ptName;
                                                if ((this.optFormData[fieldId + "_ptX"] && this.optFormData[fieldId + "_ptY"]) || this.optFormData[fieldId + "_ptArea"]) {
                                                    if (type === 'spot') {
                                                        gisInfo["ptX"] = this.optFormData[fieldId + "_ptX"];
                                                        gisInfo["ptY"] = this.optFormData[fieldId + "_ptY"];
                                                    } else {
                                                        gisInfo["ptArea"] = this.optFormData[fieldId + "_ptArea"];
                                                    }
                                                    gisInfo["ptName"] = this.optFormData[ptNameFieldId] ? this.optFormData[ptNameFieldId] : item.specialSet.ptNameDefault;
                                                    gisInfo["type"] = type;
                                                    gisInfo["formId"] = this.formId;
                                                    gisInfo["relationId"] = dataId;
                                                    gisInfoArr.push(gisInfo);
                                                } else if (type === 'spot' && this.optFormData[item.specialSet.lng] && this.optFormData[item.specialSet.lat]) {
                                                    gisInfo["ptX"] = this.optFormData[item.specialSet.lng];
                                                    gisInfo["ptY"] = this.optFormData[item.specialSet.lat];
                                                    gisInfo["ptName"] = this.optFormData[ptNameFieldId] ? this.optFormData[ptNameFieldId] : item.specialSet.ptNameDefault;
                                                    gisInfo["type"] = type;
                                                    gisInfo["formId"] = this.formId;
                                                    gisInfo["relationId"] = dataId;
                                                    gisInfoArr.push(gisInfo);
                                                }
                                            });
                                            if (gisInfoArr.length > 0) {
                                                this.spcpFormAxios.post(this.api.gisMapDoting.batchAdd, {
                                                    insertObj: JSON.stringify(gisInfoArr)
                                                });
                                            }
                                        }

                                        if(Number(this.tableviewsData.openUpdateLog)){
                                            this.setUpdateRecord(dataId,operate);
                                        }

                                        if(this.operate == "add"){
                                            // this.updateRelativeInfo(isEditTable,res).then(() => {
                                            //执行保存后脚本
                                            this.scriptDataArr.forEach(scriptData => { //提交前脚本执行
                                                this.execAfterScripts(scriptData,'save', 'Submit');
                                            });
                                            // });
                                            if (this.contentArr.some(item => item.isUserBackfill === "1") && !this.userBackfillDataId){
                                                this.userBackfillSaveData("add");
                                            }
                                            if (this.userBackfillDataId){
                                                this.userBackfillSaveData("update");
                                            }
                                        }else{//执行保存后脚本
                                            this.scriptDataArr.forEach(scriptData => { //提交前脚本执行
                                                this.execAfterScripts(scriptData,'save', 'Submit');
                                            });

                                        }
                                        this.operate = "update";
                                    } else {
                                        contentForm["flowSaveSuccess"] = false;
                                    }
                                    if(!this.isFlow && saveMessage !== "success"){
                                        this.$message({message: msg, type: type});
                                    }
                                    let result = res.data || {};
                                    contentForm["flowDataId"] = result.operateObj;
                                    result["formDataObj"] = contentForm; // 置入表单数据
                                    resolve(result);
                                }
                            });
                        }
                    }else{
                        this.validateFail();
                        resolve(false);
                    }
                });
            });
        },

        // 编辑表单保存事件
        saveDataTableForm(loginUserId,saveMessage,relationId) {
            return new Promise(resolve => {
                let enclosureArr = [];
                Object.values(this.dataAllObj).forEach(item => {
                    if(item.controlType == "enclosure"){
                        enclosureArr.push(item.fieldId);
                    }
                });
                Object.keys(this.optFormData).forEach(item => {
                    if(enclosureArr.indexOf(item) != -1){
                        this.optFormData[item] = "";
                    }
                });
                //执行提交前的代码
                Object.keys(this.optFormData).forEach(key => {
                    if(!this.optFormData[key]){
                        this.optFormData[key] = "";
                    }
                })
                //判断是否存在富文本编辑器的字段有的话把单引号转义
                if(Object.keys(this.plUeditorObj).length>0){
                    Object.keys(this.optFormData).forEach(item =>{
                        if(this.plUeditorObj[item] && this.optFormData[item].includes("'")){
                            let str=this.optFormData[item].split("'").join("\\'");
                            this.$set(this.optFormData,item,str);
                        }
                    })
                }
                let contentForm = JSON.parse(JSON.stringify(this.optFormData));
                contentForm = this.dealSubmitData(contentForm);
                (Object.keys(contentForm) || []).forEach(item => {
                    if(item.includes("editTable_")) {
                        delete contentForm[item];
                    }
                })
                let paramObj = {};
                let operate = "";
                contentForm["UPDATED"] = loginUserId;
                //如果时复制删除
                if(this.isCopyOperate){
                    delete contentForm.ID;
                    delete contentForm["CREATE_TIME"];
                    delete contentForm["UPDATE_TIME"];
                    delete contentForm["STATUS"];
                    delete contentForm["CREATE_ORG"];
                    delete contentForm["CREATE_POS"];
                }
                if (this.operate !== "add" && contentForm.ID) {
                    delete contentForm["CREATE_TIME"];
                    delete contentForm["UPDATE_TIME"];
                    paramObj = {
                        formId: this.formId,
                        dataId: contentForm.ID,
                        updateParams: JSON.stringify(contentForm)
                    };
                    operate = "updateById"; //修改
                } else {
                    contentForm["RELATION_ID"] = relationId;
                    contentForm["ID"] = relationId;
                    contentForm["CREATED"] = loginUserId;
                    paramObj = {formId: this.formId, params: JSON.stringify(contentForm)};
                    operate = "insert"; //新增
                }
                //追加意见提交
                this.addCommentsFields.forEach(item=>{
                    this.$refs[item] && this.$refs[item].onAddComment();
                });
                this.groupRefs.forEach(item => {
                    this.$refs[item] && this.$refs[item].submitComment();
                })
                // end
                this.spcpFormAxios.post(this.api.plCommonmethod.url + "/" + operate, paramObj).then(res => {
                    if (res && res.data) {
                        let type = "danger";
                        let msg = "保存失败！";
                        contentForm["flowSaveSuccess"] = true;
                        if (res.data.operateSuccess) {
                            type = "success";
                            msg = "保存成功！";
                            if(saveMessage){
                                msg = saveMessage;
                            }
                            //删除附件
                            if(this.tempRemoveUploadFile.length > 0){
                                this.spcpFormAxios.post(this.api.baseUploadUrl + "delete", {"ids": this.tempRemoveUploadFile.join(",")});
                            }

                            let dataId = contentForm.ID || res.data.operateObj; // 修改时是有id的，添加时返回值有id
                            if(!this.optFormData.ID){ // 添加后将Id置入
                                this.optFormData.ID = dataId;
                            }

                            if(Number(this.tableviewsData.openUpdateLog)){
                                this.setUpdateRecord(dataId,operate);
                            }
                            this.operate = "update";
                        } else {
                            contentForm["flowSaveSuccess"] = false;
                        }
                        if(!this.isFlow && saveMessage !== "success"){
                            this.$message({message: msg, type: type});
                        }
                        let result = res.data || {};
                        contentForm["flowDataId"] = result.operateObj;
                        result["formDataObj"] = contentForm; // 置入表单数据
                        if(result) {
                            resolve(result);
                        }else {
                            resolve(false);
                        }
                    }
                });
            })
        },

        validateFail(){
            // 定位错误位置，。pl-el-form
            this.$nextTick(() => {
                let dom = this.$refs['tableFormRef'].$el;
                let isError= dom.getElementsByClassName("is-error");
                dom.scrollTop = isError[0].offsetParent.offsetParent.offsetTop - 20;
            });
        },

        updateRelativeInfo(isEditTable,res){
            return new Promise(resolve => {
                let count = 1;
                if(isEditTable != "1"){
                    count += this.editTableFormId.length;
                }
                let dataCount = {"count":count};
                Object.keys(this.uploadFkInfo).forEach(field => {
                    this.spcpFormAxios.post(this.api.upload.updateByFkId,
                        {"fkId":res.data.operateObj + "_" + field,"oldFkId":this.uploadFkInfo[field]}).then(() => {
                        this.finishInfo(dataCount,resolve);
                    })
                });
                // if(isEditTable != "1"){
                let mainFormId = res.data.operateObj;
                let searchObj = [{controlType:"defaultField",key:"RELATION_ID",operate:"=",value:this.relationId}];
                if (this.editTableFormId.length > 0) {
                    this.editTableFormId.forEach(editFormId => {
                        let updateObj = {"RELATION_ID":mainFormId};
                        let updateParamsArr = this.editFormUpdateParams[editFormId] || [];
                        updateParamsArr.forEach(updateParam => {
                            updateObj[updateParam] = mainFormId;
                        })

                        this.spcpFormAxios.post(this.api.plCommonmethod.update,
                            {formId:editFormId,updateParams:JSON.stringify(updateObj),queryParams:JSON.stringify(searchObj)}).then(() => {
                            this.finishInfo(dataCount,resolve);
                        })
                    });
                } else {
                    resolve();
                }
                // }
            })
        },

        finishInfo(dataCount,resolve){
            dataCount["count"] = dataCount["count"] - 1;
            if(!dataCount["count"]){
                resolve();
            }
        },

        /**
         * 设置变更记录
         */
        setUpdateRecord(dataId,operate){
            // 设置变更记录
            let updateType = "";
            let updateContent = "";
            if(operate == "insert"){ // 新增
                updateType = "add";
            }
            if(operate == "updateById"){ // 修改
                updateType = "update";
                updateContent = this.getUpdateField();
                if(Object.keys(updateContent).length == 0){ // 无变更
                    return;
                }
            }
            this.spcpFormAxios.post(this.api.plUpdateRecord.add, {
                "formId":this.formId,"dataId":dataId,
                "updateDataUser":this.loginUser.id,"updateType":updateType,
                "updateContent":JSON.stringify(updateContent || "{}"), "updateDataUserName":this.loginUser.userName
            })
        },

        /**
         * 比对变化的字段
         */
        getUpdateField(){
            let optFormData = JSON.parse(JSON.stringify(this.optFormData));
            let initFormData = JSON.parse(JSON.stringify(this.initFormData));
            let noCompareField = ["CREATED","CREATE_TIME","ID","STATUS","UPDATED","UPDATE_TIME"];
            let result = {};
            // 开始比对
            let optKeyArr = Object.keys(optFormData);
            let initKeyArr = Object.keys(initFormData);
            optKeyArr.forEach(key => {
                let optValue = optFormData[key] || "";
                let initValue = initFormData[key] || "";

                if(key.indexOf("_sequence") > -1){ // 自增序列比对时，初始化的值key没有_sequence，要去除_sequence对比
                    initValue = initFormData[key.replace("_sequence","")];
                }

                if(optKeyArr.indexOf(key + "_sequence") > -1){ // 自增序列
                    optValue = optFormData[key + "_sequence"] || "";
                }

                if(Array.isArray(optValue) && !Array.isArray(initValue)){
                    initValue = initValue.split(",");
                }
                if(!this.isEqual(optValue,initValue)){ // 不相等
                    if(Array.isArray(optValue)){
                        optValue = optValue.join(",");
                    }else if(optValue instanceof Object){
                        optValue = JSON.stringify(optValue);
                    }
                    if(Array.isArray(initValue)){
                        initValue = initValue.join(",");
                    }else if(initValue instanceof Object){
                        initValue = JSON.stringify(initValue);
                    }
                    if(this.fieldSysDataObj[key]){ // 元数据
                        let optValueArr = [];
                        optValue && (optValueArr = optValue.split(","));
                        let initValueArr = [];
                        initValue && (initValueArr = initValue.split(","));
                        let optNameArr = [];
                        optValueArr.forEach(value => {
                            optNameArr.push(this.fieldSysDataObj[key][value] || value); // 值转name
                        });
                        let initNameArr = [];
                        initValueArr.forEach(value => {
                            initNameArr.push(this.fieldSysDataObj[key][value] || value); // 值转name
                        });
                        optValue = optNameArr.join(",");
                        initValue = initNameArr.join(",");
                    }
                    result[key] = {"old":initValue || "","new":optValue || ""};
                }
            });
            initKeyArr.forEach(key => {
                if(noCompareField.indexOf(key) == -1 && optKeyArr.indexOf(key) == -1){
                    let initValue = initFormData[key];
                    if(!initValue){
                        return;
                    }
                    if(Array.isArray(initValue)){
                        initValue = initValue.join(",");
                    }else if(initValue instanceof Object){
                        initValue = JSON.stringify(initValue);
                    }
                    if(this.fieldSysDataObj[key]){ // 元数据
                        let initValueArr = [];
                        initValue && (initValueArr = initValue.split(","));
                        let initNameArr = [];
                        initValueArr.forEach(value => {
                            initNameArr.push(this.fieldSysDataObj[key][value] || value); // 值转name
                        });
                        initValue = initNameArr.join(",");
                    }
                    result[key] = {"old":initValue || "","new":""};
                }
            });
            Object.assign(result,this.uploadRecord);
            return result;
        },

        isEqual(obj1,obj2){
            let vm = this;
            let o1 = obj1 instanceof Object;
            let o2 = obj2 instanceof Object;
            if(!o1 || !o2){/*  判断不是对象  */
                return obj1 === obj2;
            }

            if(Array.isArray(obj1) && Array.isArray(obj2)){
                return vm.compareArray(obj1,obj2);
            }

            if(Object.keys(obj1).length !== Object.keys(obj2).length){
                return false;
            }

            for(let attr in obj1){
                if (obj1.hasOwnProperty(attr)) {
                    let t1 = obj1[attr] instanceof Object;
                    let t2 = obj2[attr] instanceof Object;
                    if(t1 && t2){
                        return this.isEqual(obj1[attr],obj2[attr]);
                    }else if(obj1[attr] !== obj2[attr]){
                        return false;
                    }
                }
            }
            return true;
        },
        compareArray(array1,array2){
            let vm = this;
            if(array1.length != array2.length){
                return false;
            }
            let obj = {}; // 记录已经比对过的数组序号
            for(let i = 0 ; i < array1.length ; i++){
                let caculate = true;
                for(let j = 0; j < array2.length ; j++){
                    if(obj[j]){ // 已经比对过，跳过
                        continue;
                    }
                    caculate = vm.isEqual(array1[i],array2[j]);
                    if(caculate){
                        obj[j] = i;
                        break;
                    }
                }
                if(!caculate){
                    break;
                }
            }
            return Object.keys(obj).length == array1.length;
        },

        /**
         * 关闭弹出框
         * @param buttonType
         */
        closeDialog(closeMessage){
            //执行关闭窗口前
            this.scriptDataArr.forEach(scriptData => { //关闭前执行脚本
                this.execBeforeScripts(scriptData,'close', 'Close');
            });

            let flag = true;
            if(closeMessage){
                this.$confirm(closeMessage, '提示', {confirmButtonText: '确定', cancelButtonText: '取消', type: 'warning'}).then(() => {
                    flag = false;
                    this.$emit("changeValue");
                    this.scriptDataArr.forEach(scriptData => { // //执行关闭窗口后脚本
                        this.execAfterScripts(scriptData,'close', 'Close');
                    });
                });
            }else{
                flag = false;
                this.scriptDataArr.forEach(scriptData => { // //执行关闭窗口后脚本
                    this.execAfterScripts(scriptData,'close', 'Close');
                });
                this.$emit("changeValue");
            }
        },
        /**
         * 表单事件绑定
         * @param field
         */
        bindViewsEvent(field){ // 绑定表单视图事件
            let $on = {};
            if(this.viewsEventMap && this.viewsEventMap[field]){
                const evtKeys = Object.keys(this.viewsEventMap[field]);
                let evt = null;
                evtKeys.forEach(evtKey => {
                    if(evtKey == 'change' || evtKey == 'input'){ //值改变或者change使用动态监听
                        if(!this.viewsEventBind[field]){
                            this.viewsEventBind[field] = {};
                        }
                        if(this.viewsEventBind[field][evtKey]){
                            return;
                        }
                        if(!this.viewsEventBind[field][evtKey]){
                            this.viewsEventBind[field][evtKey] = true;
                        }
                        this.$watch(function () {
                            return this.optFormData[field];
                        },function () {
                            //执行脚本
                            evt = this.viewsEventMap[field][evtKey];
                            evt(...this.argumens);
                        } );
                    }else {
                        evt = this.viewsEventMap[field][evtKey];
                        $on[evtKey] = evt.bind(this,...this.argumens);
                    }
                });
            }
            // 移除无效的事件，undefined报错
            Object.keys($on).forEach(key => {
                if(!$on[key]){
                    delete $on[key];
                }
            });
            return $on;
        },

        /**
         * 表单事件规则绑定
         */
        bindTableViewsEvent(field){ //表单绑定事件规则
            let $on = {};
            if(this.controlEventObj[field]){ //老事件规则控件触发
                //编辑渲染隐藏条件
                // this.dataAllObj["204"].visible = 'false';
                const evtKeys =  Object.keys(this.controlEventObj[field]);
                let evt = null;
                evtKeys.forEach(evtKey => {
                    evt = this.controlEventObj[field][evtKey] || [];
                    $on[evtKey] = this.runTableviewEvntFunc.bind(null,evt);
                });
            }
            if(this.newControlEventObj[field]){ //新事件规则方法
                const evtKeys =  Object.keys(this.newControlEventObj[field]);
                let evt = null; //响应配置
                evtKeys.forEach(evtKey => {
                    evt = this.newControlEventObj[field][evtKey] || [];
                    //记录当前影响的字段
                    $on[evtKey] = this.newRunTableviewEventFunc.bind(null,evt);
                });
            }
            // 移除无效的事件，undefined报错
            Object.keys($on).forEach(key => {
                if(!$on[key]){
                    delete $on[key];
                }
            });
            return $on;
        },

        /**
         * 事件规则统一方法
         */
        runTableviewEvntFunc(eventArr){
            (eventArr||[]).forEach(event =>{
                (event.fieldId).forEach(field =>{
                    if(this.dataAllObj[field]){
                        if(event.eventType == 'hidden'){
                            this.dataAllObj[field].visible = 'false';
                        }else if(event.eventType == 'show'){
                            this.dataAllObj[field].visible = 'true';
                        }else if(event.eventType == 'editTitle'){ //影响标题
                            this.dataAllObj[field].showName = event.affectContent.editTitle || '';
                            if(event.affectContent.titleBgColor){
                                this.$set(this.dataAllObj[field]["td-style"],"background-color",event.affectContent.titleBgColor);
                            }
                            if(event.affectContent.titleFontColor){
                                this.$set(this.dataAllObj[field]["td-style"],"color",event.affectContent.titleFontColor);
                            }
                            if(event.affectContent.titleFontSize){
                                this.$set(this.dataAllObj[field]["td-style"],"font-size",event.affectContent.titleFontSize + "px");
                            }
                            if(event.affectContent.titleFontLean == "1"){
                                this.$set(this.dataAllObj[field]["td-style"],"font-style","italic");
                            }
                            if(event.affectContent.titleFontWeight == "1"){
                                this.$set(this.dataAllObj[field]["td-style"],"font-weight","bold");
                            }
                            if(event.affectContent.titleTextDecoration == "1"){
                                this.$set(this.dataAllObj[field]["td-style"],"text-decoration","underline");
                            }
                        }else if(event.eventType == 'editContent'){ //影响内容
                            let val = '';
                            let value = event.affectContent.value;
                            if(event.affectContent.dataSource == 'formField'){ //表单字段
                                val = this.optFormData[value] || "";
                            }else if(event.affectContent.dataSource == 'default'){ //缺省值
                                if(value.indexOf("LOGINUSERDEPT") > -1){
                                    val = Replace.def(this.userDept,value) || "";
                                }else if(value.indexOf("LOGINUSER") > -1){
                                    val = Replace.def(this.loginUser,value) || "";
                                }else {//系统时间
                                    if(this.dataAllObj[field]){
                                        val = this.viewDateFormat(new Date(),
                                            this.dataAllObj[field].displayFormatter || 'yyyy-MM-dd');
                                    }
                                }
                            }else { //自定义
                                val = value;
                            }
                            this.$set(this.optFormData,field,val); //修改内容
                        }else if(event.eventType == 'editControl'){
                            if(event.affectContent.editable){
                                this.$set(this.dataAllObj[field],"editable",event.affectContent.editable);
                            }
                            if(event.affectContent.isRequired){
                                this.$set(this.dataAllObj[field],"isRequired",event.affectContent.isRequired);
                            }
                            if(event.affectContent.bgColor){
                                if(!this.dataAllObj[field]["control-style"]){ //控件样式
                                    this.$set(this.dataAllObj[field],'control-style',{});
                                }
                                this.$set(this.dataAllObj[field]["control-style"],"background-color",event.affectContent.bgColor);
                            }
                            let controlCss = this.dataAllObj[field].controlCss;
                            let fontColor = event.affectContent.fontColor;
                            let fontSize = event.affectContent.fontSize;
                            let showFontLean = event.affectContent.showFontLean;
                            let showFontWeight = event.affectContent.showFontWeight == "1";
                            let css = "";
                            if(controlCss){
                                let cssArr = controlCss.split(";");
                                cssArr.forEach(cssStr => {
                                    if(cssStr.includes("color:") && fontColor){
                                        css += ";color:" + fontColor;
                                    }
                                    if(cssStr.includes("font-size:") && fontSize){
                                        css += ";font-size:" + fontSize + "px";
                                    }
                                    if(cssStr.includes("font-style:") && showFontLean == "1"){
                                        css += ";font-style:italic";
                                    }
                                    if(cssStr.includes("font-weight:") && showFontWeight == "1"){
                                        css += ";font-weight:bold";
                                    }
                                });
                            }else{
                                if(fontColor){
                                    css += ";color:" + fontColor;
                                }
                                if(fontSize){
                                    css += ";font-size:" + fontSize + "px";
                                }
                                if(showFontLean == "1"){
                                    css += ";font-style:italic";
                                }
                                if(showFontWeight == "1"){
                                    css += ";font-weight:bold";
                                }
                            }
                            if(css){
                                css = css.substring(1);
                            }
                            this.$set(this.dataAllObj[field],"controlCss",css);
                            this.affectContentOtherArr.forEach(key =>{
                                if(event.affectContent[key]){
                                    this.$set(this.dataAllObj[field],key,event.affectContent[key]);
                                }
                            });
                        }
                    }
                });
            });
        },


        /**
         * 新事件规则-渲染方法
         * @affectContentList 响应内容arr
         */
        newRunTableviewEventFunc(affectContentList){
            affectContentList.forEach(affectContentArr =>{
                (affectContentArr||[]).forEach(affectContent =>{
                    if(affectContent.eventKey
                        && this.installListObj[affectContent.eventKey]
                        && this.installListObj[affectContent.eventKey]["config"]
                        && this.installListObj[affectContent.eventKey]["config"].methods.renderTableViewConfig){
                        //调用渲染方法
                        (affectContent.fieldId || []).forEach(field => { //遍历字段
                            this.$set(affectContent,"field",field);
                            //记录控件触发的切换隐藏显示
                            if(affectContent.eventKey == 'system-is-show-config'){
                                let visible = (affectContent.isShow == "1") + "";
                                if(!affectContent.changeView || affectContent.changeView == '0'){
                                    this.$set(this.dataAllObj[field],"visible",visible);
                                }else if (affectContent.changeView == '1') { //开启切换
                                    if(this.dataAllObj[field]["visible"] == 'true'){ //当前为显示
                                        this.$set(this.dataAllObj[field],"visible","false");
                                    }else {
                                        this.$set(this.dataAllObj[field],"visible","true");
                                    }
                                }
                            }else {
                                this.installListObj[affectContent.eventKey]["config"].methods.renderTableViewConfig(this,this.CTX,this.spcpFormAxios,this.dataAllObj,affectContent);
                            }
                        });
                    }
                });
            });
        },

        /**
         * 事件规则-条件触发
         */
        async getVisiableByCondition(){
            if(!this.conditionEventRuleArr || this.conditionEventRuleArr.length == 0){
                await this.loadTableViewsEvent();
            }
            this.delayWatchData = false;
            //老条件定义触发
            (this.conditionEventRuleArr || []).forEach(eventObj => {
                let controlArr = eventObj.fieldId || [];
                controlArr.forEach(item => {
                    let result = this.getRuleCondition(eventObj,item);
                    if(result == "true") {
                        if(eventObj.eventType == 'show' || eventObj.eventType == 'hidden'){
                            let visible = (eventObj.eventType == "show") + "";
                            this.$set(this.dataAllObj[item] || {},"visible",visible);
                        }
                        //根据条件修改-标题
                        if(eventObj.eventType == 'editTitle'){
                            this.$set(this.dataAllObj[item],"showName",eventObj.affectContent.editTitle || '');
                            if(eventObj.affectContent.titleBgColor){
                                this.$set(this.dataAllObj[item]["td-style"],"background-color",eventObj.affectContent.titleBgColor);
                            }
                            if(eventObj.affectContent.titleFontColor){
                                this.$set(this.dataAllObj[item]["td-style"],"color",eventObj.affectContent.titleFontColor);
                            }
                            if(eventObj.affectContent.titleFontSize){
                                this.$set(this.dataAllObj[item]["td-style"],"font-size",eventObj.affectContent.titleFontSize + "px");
                            }
                            if(eventObj.affectContent.titleFontLean == "1"){
                                this.$set(this.dataAllObj[item]["td-style"],"font-style","italic");
                            }
                            if(eventObj.affectContent.titleFontWeight == "1"){
                                this.$set(this.dataAllObj[item]["td-style"],"font-weight","bold");
                            }
                            if(eventObj.affectContent.titleTextDecoration == "1"){
                                this.$set(this.dataAllObj[item]["td-style"],"text-decoration","underline");
                            }
                        }else if(eventObj.eventType == 'editContent'){ //修改内容
                            let val = '';
                            let value = eventObj.affectContent.value;
                            if(eventObj.affectContent.dataSource == 'formField'){ //表单字段
                                val = this.optFormData[value] || "";
                            }else if(eventObj.affectContent.dataSource == 'default'){ //缺省值
                                if(value.indexOf("LOGINUSERDEPT") > -1){
                                    val = Replace.def(this.userDept,value) || "";
                                }else if(value.indexOf("LOGINUSER") > -1){
                                    val = Replace.def(this.loginUser,value) || "";
                                }else {//系统时间
                                    if(this.dataAllObj[item]){
                                        val = this.viewDateFormat(new Date(),
                                            this.dataAllObj[item].displayFormatter || 'yyyy-MM-dd');
                                    }
                                }
                            }else { //自定义
                                val = value;
                            }
                            this.$set(this.optFormData,item,val); //修改内容
                        }else if(eventObj.eventType == 'editControl'){
                            if(eventObj.affectContent.editable){
                                this.$set(this.dataAllObj[item],"editable",eventObj.affectContent.editable);
                            }
                            if(eventObj.affectContent.isRequired){
                                this.$set(this.dataAllObj[item],"isRequired",eventObj.affectContent.isRequired);
                            }

                            if(eventObj.affectContent.bgColor){
                                if(!this.dataAllObj[item]["control-style"]){ //控件样式
                                    this.$set(this.dataAllObj[item],'control-style',{});
                                }
                                this.$set(this.dataAllObj[item]["control-style"],"background-color",eventObj.affectContent.bgColor);
                            }

                            let controlCss = this.dataAllObj[item].controlCss;
                            let fontColor = eventObj.affectContent.fontColor;
                            let fontSize = eventObj.affectContent.fontSize;
                            let showFontLean = eventObj.affectContent.showFontLean;
                            let showFontWeight = eventObj.affectContent.showFontWeight == "1";
                            let css = "";
                            if(controlCss){
                                let cssArr = controlCss.split(";");
                                cssArr.forEach(cssStr => {
                                    if(cssStr.includes("color:") && fontColor){
                                        css += ";color:" + fontColor;
                                    }
                                    if(cssStr.includes("font-size:") && fontSize){
                                        css += ";font-size:" + fontSize + "px";
                                    }
                                    if(cssStr.includes("font-style:") && showFontLean == "1"){
                                        css += ";font-style:italic";
                                    }
                                    if(cssStr.includes("font-weight:") && showFontWeight == "1"){
                                        css += ";font-weight:bold";
                                    }
                                });
                            }else{
                                if(fontColor){
                                    css += ";color:" + fontColor;
                                }
                                if(fontSize){
                                    css += ";font-size:" + fontSize + "px";
                                }
                                if(showFontLean == "1"){
                                    css += ";font-style:italic";
                                }
                                if(showFontWeight == "1"){
                                    css += ";font-weight:bold";
                                }
                            }
                            if(css){
                                css = css.substring(1);
                            }
                            this.$set(this.dataAllObj[item],"controlCss",css);
                            this.affectContentOtherArr.forEach(key =>{
                                if(eventObj.affectContent[key]){
                                    this.$set(this.dataAllObj[item],key,eventObj.affectContent[key]);
                                }
                            });
                        }
                    }
                });
            });

            //新条件定义触发
            (this.newConditionEventRuleArr || []).forEach(eventObj => {
                let affectContent = eventObj.affectContent || []; //响应配置
                //需要记录响应字段（当前触发都是批量的所以）
                affectContent.forEach(affect =>{
                    //解析
                    (affect.fieldId || []).forEach(field =>{
                        //执行
                        let result = this.newGetRuleCondition(eventObj,field,affect.eventKey); //解析新条件
                        //执行
                        if(eventObj.isTriggerOnce == '1'){
                            this.isTriggerOnceObj[eventObj.id+"_"+field] = true;
                        }
                        if(result){
                            if(affect.eventKey
                                && this.installListObj[affect.eventKey]
                                && this.installListObj[affect.eventKey]["config"]
                                && this.installListObj[affect.eventKey]["config"].methods.renderTableViewConfig){
                                //调用渲染方法
                                this.$set(affect,"field",field);//当前响应控件
                                let valid = this.installListObj[affect.eventKey]["config"].methods.renderTableViewConfig(this,this.CTX,this.spcpFormAxios,this.dataAllObj,affect);
                                //记录执行事件后的字段
                                if(affect.eventKey == 'system-is-show-config' && affect.changeView == '1'){
                                    this.useEventFieldVisible[field] = this.dataAllObj[field]["visible"]; //记录执行事件后的隐藏显示
                                }
                                if(valid && this.tableviewsData.hidePosition != 'normal'){
                                    let scrollPos = null;
                                    if(this.$refs.tableFormRef){
                                        scrollPos = this.$refs.tableFormRef.$el.scrollTop;
                                    }
                                    if(this.renderModel === "render"){
                                        this.loadDataSuccess = false;
                                        this.$nextTick(() => {
                                            let result = new commonRender().renderTrs(this.contentArr,'pc',this.inGroupFieldIdArr,this.operate,this.inTabsFieldIdArr);
                                            this.renderArr = result[0];
                                            this.loadDataSuccess = true;
                                            this.$nextTick(() => {
                                                scrollPos && (this.$refs.tableFormRef.$el.scrollTop = scrollPos);
                                            })
                                        })
                                    }
                                }
                            }
                        }else{
                            if(affect.eventKey == 'system-is-show-config' && affect.changeView == '1' && !this.isTriggerOnceObj[eventObj.id+"_"+field]){
                                //如果是隐藏和显示并且 开启 条件切换
                                let valid = false;
                                if(this.useEventFieldVisible[field]){
                                    if(this.useEventFieldVisible[field] == 'true'){ //当前为显示并且
                                        valid = this.dataAllObj[field]["visible"] !== "false";
                                        this.$set(this.dataAllObj[field],"visible","false");
                                    }else if(this.useEventFieldVisible[field] != 'true'){ //如果当前字段隐藏且为显示
                                        valid = this.dataAllObj[field]["visible"] !== "true";
                                        this.$set(this.dataAllObj[field],"visible","true");
                                    }
                                }else { //首次没有执行
                                    if(affect.isShow == '1'){ //当前为显示并且
                                        valid = this.dataAllObj[field]["visible"] !== "false";
                                        this.$set(this.dataAllObj[field],"visible","false");
                                    }else if(affect.isShow == '0'){ //如果当前字段隐藏且为显示
                                        valid = this.dataAllObj[field]["visible"] !== "true";
                                        this.$set(this.dataAllObj[field],"visible","true");
                                    }
                                }
                                if(valid && this.tableviewsData.hidePosition != 'normal'){
                                    let scrollPos = null;
                                    if(this.$refs.tableFormRef){
                                        scrollPos = this.$refs.tableFormRef.$el.scrollTop;
                                    }
                                    if(this.renderModel === "render"){
                                        this.loadDataSuccess = false;
                                        this.$nextTick(() => {
                                            let result = new commonRender().renderTrs(this.contentArr,'pc',this.inGroupFieldIdArr,this.operate,this.inTabsFieldIdArr);
                                            this.renderArr = result[0];
                                            this.loadDataSuccess = true;
                                            this.$nextTick(() => {
                                                scrollPos && (this.$refs.tableFormRef.$el.scrollTop = scrollPos);
                                            })
                                        })
                                    }
                                }
                            }
                        }

                    });
                });
            });

            this.$nextTick(() => {
                this.delayWatchData = true;
            })
        },
        /**
         * 事件规则 拼接结果
         */
        getRuleCondition(eventObj,id){
            let resultArr = [];
            let detailArr = eventObj.conditionDetailArr || [];
            detailArr.forEach(item => {
                let condition = "";
                //符号左边的值
                let param = item.fieldId == "formStatus" ? this.operate : (this.optFormData[item.fieldId] || "");
                param = param||"";
                if(this.allLoadRuleData[item.fieldId]){
                    if(id && this.allLoadRuleData[item.fieldId][id] && this.allLoadRuleData[item.fieldId][id] == param){
                        return;
                    }
                    if(this.allLoadRuleData[item.fieldId] == param){
                        return;
                    }
                }
                //操作
                let operaSign = item.operaSign;
                //操作符右边的值
                let value = item.value || "";
                //if(value){
                //处理值
                if(item.valType == "default"){
                    if(value.indexOf("LOGINUSER") > -1){
                        value = Replace.def(this.loginUser,value) || "";
                    }else{
                        value = Replace.def(this.userDept,value) || "";
                    }
                }else if(item.valType == "formField"){
                    value = this.optFormData[item.value] || "";
                }
                //执行语句
                if(operaSign == "=="){
                    condition = (param == value);
                }else if(operaSign == ">"){
                    condition = (param > value);
                }else if(operaSign == "<"){
                    condition = (param < value);
                }else if(operaSign == ">="){
                    condition = (param >= value);
                }else if(operaSign == "<="){
                    condition = (param <= value);
                }else if(operaSign == "!="){
                    condition = (param != value);
                }else if(operaSign == "IN"){
                    if(value.includes(",")){
                        let arr=value.split(",") || [];
                        condition =arr.includes(param)
                    }else{
                        condition = (param.indexOf(value) > -1);
                    }
                }else if(operaSign == "NOT IN"){
                    if(value.includes(",")){
                        let val = value.split(",") || [];
                        condition =!val.includes(param)
                    }else{
                        condition = (param.indexOf(value) > -1);
                    }
                    condition = (param.indexOf(value) == -1);
                }else if(operaSign == "IS NULL"){
                    condition = (!param);
                }else if(operaSign == "IS NOT NULL"){
                    condition = (!!param);
                }
                //记录值
                resultArr.push(condition);
                if(condition || condition == "true"){
                    if(id){
                        //this.$set(this.allLoadRuleData,item.fieldId,param);
                        if(!this.allLoadRuleData[item.fieldId]){
                            this.allLoadRuleData[item.fieldId]={};
                        }
                        if(!this.allLoadRuleData[item.fieldId]){

                        }
                        this.allLoadRuleData[item.fieldId][id]=param;
                    }else{

                        this.$set(this.allLoadRuleData,item.fieldId,param);
                    }
                }else{
                    delete this.allLoadRuleData[item.fieldId];
                }
                //}
            });

            //判断验证是否通过
            if(resultArr.length == 0 || resultArr.indexOf(false) > -1 || resultArr.indexOf("false") > -1){
                return "false";
            }else{
                return "true";
            }
        },


        /**
         * 新事件规则 条件拼接结果
         */
        newGetRuleCondition(eventObj,id,eventKey){
            //解析执行每一行结果，然后根据 左连接（默认and） if 拼接结果值
            let detailArr = eventObj.conditionDetailArr || [];
            let reultFunc = "1==1"; //逻辑条件拼接
            if(this.isTriggerOnceObj[eventObj.id+"_"+id]){
                return false;
            }
            let conditionLength = detailArr.length;
            detailArr.forEach(item => {
                let condition = "";
                //符号左边的值
                let param = item.fieldId == "formStatus" ? this.operate : (this.optFormData[item.fieldId] || "");
                param = param||"";
                //左侧值
                let connectSignLeft = item.connectSignLeft; //左连接符号
                if(!conditionLength && conditionLength == 1){ //如果左侧连接符不存在，并且只有一个条件，左侧连接符加 AND
                    connectSignLeft = "AND";
                }
                if(connectSignLeft){
                    reultFunc += this.connectSignObj[connectSignLeft];
                }

                //操作符右边的值
                let value = item.value || "";
                //if(value){
                //处理值
                if(item.valType == "default"){
                    if(value.indexOf("LOGINUSER") > -1){
                        value = Replace.def(this.loginUser,value) || "";
                    }else{
                        value = Replace.def(this.userDept,value) || "";
                    }
                }else if(item.valType == "formField"){
                    value = this.optFormData[item.value] || "";
                }

                if(this.allLoadRuleData[item.id] &&  this.allLoadRuleData[item.id][item.fieldId] && eventKey != 'system-is-show-config'){
                    if(id && this.allLoadRuleData[item.id][item.fieldId][id]
                          && this.allLoadRuleData[item.id][item.fieldId][id] == param
                          && this.allLoadRuleData[item.id][item.fieldId][id + "_value"] == value){
                        reultFunc += "true";
                        if(item.connectSignRight){
                            reultFunc += item.connectSignRight;
                        }
                        return;
                    }
                    if(this.allLoadRuleData[item.id][item.fieldId] == param
                       && this.allLoadRuleData[item.id][item.fieldId + "_value"] == value){
                        reultFunc += "true";
                        if(item.connectSignRight){
                            reultFunc += item.connectSignRight;
                        }
                        return;
                    }
                }
                //操作
                let operaSign = item.operaSign;
                //执行语句
                if(operaSign == "=="){
                    condition = (param == value);
                }else if(operaSign == ">" || operaSign == "<" || operaSign == ">=" || operaSign == "<="){
                    let ret = this.transType(param,value);
                    param = ret.param;
                    value = ret.value;
                    if(operaSign == ">"){
                        condition = (param > value);
                    }else if(operaSign == "<"){
                        condition = (param < value);
                    }else if(operaSign == ">="){
                        condition = (param >= value);
                    }else if(operaSign == "<=") {
                        condition = (param <= value);
                    }
                }else if(operaSign == "!="){
                    condition = (param != value);
                }else if(operaSign == "IN"){
                    if(value.includes(",")){
                        let arr=value.split(",") || [];
                        condition =arr.includes(param)
                    }else{
                        condition = (param.indexOf(value) > -1);
                    }
                }else if(operaSign == "NOT IN"){
                    if(value.includes(",")){
                        let arr=value.split(",") || [];
                        condition =!arr.includes(param)
                    }else{
                        condition = (param.indexOf(value) > -1);
                    }
                    condition = (param.indexOf(value) == -1);
                }else if(operaSign == "IS NULL"){
                    condition = (!param);
                }else if(operaSign == "IS NOT NULL"){
                    condition = (!!param);
                }
                //记录值
                if(condition || condition == "true"){
                    if(id){
                        //this.$set(this.allLoadRuleData,item.fieldId,param);
                        if(!this.allLoadRuleData[item.id]){
                            this.allLoadRuleData[item.id]={};
                        }
                        if(!this.allLoadRuleData[item.id][item.fieldId]){
                            this.allLoadRuleData[item.id][item.fieldId]={};
                        }
                        this.allLoadRuleData[item.id][item.fieldId][id]=param;
                        this.allLoadRuleData[item.id][item.fieldId][id + "_value"]=value;
                    }else{
                        this.$set(this.allLoadRuleData[item.id],item.fieldId,param);
                        this.$set(this.allLoadRuleData[item.id],item.fieldId + "_value",value);
                    }
                }else{
                    delete this.allLoadRuleData[item.id];
                }
                reultFunc += condition;
                if(item.connectSignRight){
                    reultFunc += item.connectSignRight;
                }
            });
            let funcBody = "let result = " + reultFunc +";"+"\n";
            funcBody+= "return result;";
            if(reultFunc == '1==1'){
                return false;
            }
            let result = false;
            try {
                result = new Function(funcBody)();
            }catch (e) {
                result = false;
                console.log("事件规则条件触发配置错误！",e);
            }
            return result;
        },

        /**
         * tips控件样式
         */
        setTipsStyle(fieldId){
            let dataObj = this.dataAllObj['tips_' + fieldId];
            let styleObj = {position:'absolute',cursor:"pointer"};
            if(dataObj.topPx){
                styleObj.top = dataObj.topPx + "px";
            }
            if(dataObj.bottomPx){
                styleObj.bottom = dataObj.bottomPx + "px";
            }
            if(dataObj.leftPx){
                styleObj.left = dataObj.leftPx + "px";
            }
            if(dataObj.rightPx){
                styleObj.right = dataObj.rightPx + "px";
            }
            return styleObj;
        },


        isNeedPaddingLeft(data){
            if((data || {}).cupJointIdArr && (data || {}).cupJointIdArr.length > 0){
                let width1 = data.controlWidth || '100%';
                let  pWidth = width1.split("%")[0];
                //遍历套接字段宽度
                (data.cupJointIdArr || []).forEach((cup,index) =>{
                    if(this.dataAllObj[cup]){
                        let cupWidth =  this.dataAllObj[cup].controlWidth || '100%';
                        cupWidth = cupWidth.split("%")[0];
                        if((Number(pWidth) + Number(cupWidth)) > 100 && (!data.hideShowName || data.hideShowName == '否')){
                            //当前行换行 在  dataAllObj 中该对象赋值  isNeedPadding
                            this.$set(this.dataAllObj[cup],'isNeedPadding',true);
                            pWidth = Number(pWidth); //重置
                        }else{
                            pWidth = Number(pWidth) + Number(cupWidth);
                            this.$set(this.dataAllObj[cup],'isNeedPadding',false);
                        }
                    }
                });
            }
        },

        /**
         * 记录页面中的field对应的dataObj
         */
        rememberSysDataObj(field,dataObj){
            this.fieldSysDataObj[field] = dataObj;
        },
        /**
         * 记录附件上传的变更记录
         */
        uploadFileRecord(field,type,fileName,id){
            if(type == "add"){ // 新增
                if(!this.uploadRecord[field]){
                    this.uploadRecord[field] = {"add":[],"delete":[],"type":'upload',"name":this.dataAllObj[field]["showName"],"addId":id,"removeId":""};
                }else{
                    this.uploadRecord[field]["addId"] = this.uploadRecord[field]["addId"]+","+id;
                }
                this.uploadRecord[field]["add"].push(fileName);
            }
            if(type == "delete"){ // 删除
                if(!this.uploadRecord[field]){
                    this.uploadRecord[field] = {"add":[],"delete":[],"type":'upload',"name":this.dataAllObj[field]["showName"],"addId":"","removeId":id};
                }else{
                    this.uploadRecord[field]["removeId"] = this.uploadRecord[field]["removeId"]+","+id;
                }
                let addArr = this.uploadRecord[field]["add"];
                // 删除时确定是否是本次新上传的文件，如果是，则不添加删除和添加记录
                if(addArr.indexOf(fileName) == -1){
                    this.uploadRecord[field]["delete"].push(fileName);
                }else{
                    this.uploadRecord[field]["add"] = addArr.filter(item => {
                        return item != fileName;
                    })
                }
            }
        },

        returnTop(id){
            document.getElementById(id).scrollIntoView(true);
            // this.$refs['elMenuRef'].close('1');
        },

        /**
         * 解析复合视图标签隐藏条件
         */
        executTabHidenConfigtion(tabConditionObj){
            let hiddenObj = {};
            Object.keys(tabConditionObj).forEach(tabId =>{
                let detailArr = tabConditionObj[tabId] || [];
                let reultFunc = ""; //逻辑条件拼接
                detailArr.forEach(item => {
                    let condition = "";
                    //符号左边的值
                    let param = this.optFormData[item.fieldId] || "";
                    //左侧值
                    let connectSignLeft = item.connectSignLeft; //左连接符号
                    if(connectSignLeft){
                        reultFunc += connectSignLeft;
                    }
                    //操作
                    let operaSign = item.operaSign;
                    //操作符右边的值
                    let value = item.value || "";
                    if(!value){
                        value = item.linkFieldId || "";
                    }
                    //if(value){
                    //处理值
                    if(item.valType == "default"){
                        if(value.indexOf("LOGINUSERDEPT") > -1){
                            value = Replace.def(this.userDept,value) || "";
                        }else if(value.indexOf("LOGINUSER") > -1){
                            value = Replace.def(this.loginUser,value) || "";
                        }
                    }else if(item.valType == 'sysData'){ //数据字典
                        if(item.value){
                            let valDataArr = item.value || item.linkFieldId;
                            if(valDataArr){
                                value =  valDataArr[valDataArr.length - 1] || '';
                            }else {
                                value = "";
                            }
                        }
                    }else if(item.valType == 'sysParam' && value){ //系统参数
                        this.PARAM_GLOBAL.getByKeyAsync(value).then(res =>{
                            value = res.paramVal || '';
                        });
                    }
                    //执行语句
                    if(operaSign == "="){
                        condition = (param == value);
                    }else if(operaSign == ">" || operaSign == "<" || operaSign == ">=" || operaSign == "<="){
                        let ret = this.transType(param,value);
                        param = ret.param;
                        value = ret.value;
                        if(operaSign == ">"){
                            condition = (param > value);
                        }else if(operaSign == "<"){
                            condition = (param < value);
                        }else if(operaSign == ">="){
                            condition = (param >= value);
                        }else if(operaSign == "<=") {
                            condition = (param <= value);
                        }
                    }else if(operaSign == "<>"){
                        condition = (param != value);
                    } else if(operaSign == "IN" || operaSign == 'LIKE'){
                        if(value.includes(",")){
                            let arr=value.split(",") || [];
                            condition =arr.includes(param);
                        }else{
                            condition = (param.indexOf(value) > -1);
                        }
                    }else if(operaSign == "NOT IN"){
                        if(value.includes(",")){
                            let arr=value.split(",") || [];
                            condition =!arr.includes(param)
                        }else{
                            condition = (param.indexOf(value) > -1);
                        }
                        condition = (param.indexOf(value) == -1);
                    }
                    reultFunc += condition;
                    if(item.connectSignRight){
                        reultFunc += item.connectSignRight;
                    }
                });
                let funcBody = "let result = " + reultFunc +";"+"\n";
                funcBody+= "return result;";
                let result = false;
                try {
                    let serviceName = (window.SERVICE_NAME || {});
                    let adminServeName = serviceName.admin || "/admin/";
                    let formServeName = serviceName.form || "/form/";
                    let flowServeName = serviceName.flow || "/flow/";
                    let oaServeName = serviceName.oa || "/oaproject/";
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/admin/",adminServeName);
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/form/",formServeName);
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/flow/",flowServeName);
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/oaproject/",oaServeName);
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/oaadmin/",adminServeName);
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/oaform/",formServeName);
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/oaflow/",flowServeName);
                    if(window.ADMIN_URL && funcBody.indexOf("/admin/") > -1 || funcBody.indexOf("/oaadmin/") > -1){
                        funcBody = this.platStringUtil.replaceAll(funcBody,"/admin/", window.ADMIN_URL + "/");
                        funcBody = this.platStringUtil.replaceAll(funcBody,"/oaadmin/",window.ADMIN_URL + "/");
                    }
                    if(window.FLOW_URL && funcBody.indexOf("/flow/") > -1 || funcBody.indexOf("/oaflow/") > -1){
                        funcBody = this.platStringUtil.replaceAll(funcBody,"/flow/", window.FLOW_URL + "/");
                        funcBody = this.platStringUtil.replaceAll(funcBody,"/oaflow/",window.FLOW_URL + "/");
                    }
                    if(window.FORM_RENDER_URL && funcBody.indexOf("/form/") > -1 || funcBody.indexOf("/oaform/") > -1){
                        funcBody = this.platStringUtil.replaceAll(funcBody,"/form/", window.FORM_RENDER_URL + "/");
                        funcBody = this.platStringUtil.replaceAll(funcBody,"/oaform/",window.FORM_RENDER_URL + "/");
                    }
                    funcBody = this.platStringUtil.replaceAll(value,"window.JAVA_URL","''");
                    funcBody = this.platStringUtil.replaceAll(value,"JAVA_URL","''");
                    value = this.platStringUtil.replaceAll(value,"window.baseUrl","''");
                    value = this.platStringUtil.replaceAll(value,"baseUrl","''");
                    // console.log("funcBody..",funcBody);
                    result = new Function(funcBody)();
                }catch (e) {
                    result = false;
                    console.log("隐藏条件条件脚本执行错误！",e);
                }
                hiddenObj[tabId] = result;
            });
            return hiddenObj;
        },

        /**
         * 字段格式比较
         * @param leftValue
         * @param rightValue
         */
        transType(leftValue,rightValue){
            let ret = {};
            ret['param'] = leftValue;
            ret['value'] = rightValue;
            if(!isNaN(Number(leftValue) && !isNaN(Number(rightValue)))){ //比较数字类型
                ret['param'] = Number(leftValue);
                ret['value'] = Number(rightValue);
                //如果是日期类型
            }else  if( isNaN(leftValue)&&!isNaN(Date.parse(leftValue))
                && isNaN(rightValue)&&!isNaN(Date.parse(rightValue))){//比较日期类型
                ret['param'] = Date.parse(leftValue);
                ret['value'] = Date.parse(rightValue);
            }
            return ret;
        },

        /**
         * 动态渲染按钮隐藏条件配置
         */
        initFormBtnVisible(){
            Object.keys(this.formBtnHiddenConditionObj).forEach(btnId=>{
                let detailArr = this.formBtnHiddenConditionObj[btnId] || [];
                //解析隐藏条件
                let reultFunc = ""; //逻辑条件拼接
                detailArr.forEach(item => {
                    let condition = "";
                    //符号左边的值
                    let param = this.optFormData[item.fieldId] || "";
                    //左侧值
                    let connectSignLeft = item.connectSignLeft; //左连接符号
                    if(connectSignLeft){
                        reultFunc += connectSignLeft;
                    }
                    //操作
                    let operaSign = item.operaSign;
                    //操作符右边的值
                    let value = item.value || "";
                    //if(value){
                    //处理值
                    if(item.valType == "default"){
                        if(value.indexOf("LOGINUSERDEPT") > -1){
                            value = Replace.def(this.userDept,value) || "";
                        }else if(value.indexOf("LOGINUSER") > -1){
                            value = Replace.def(this.loginUser,value) || "";
                        }
                    }else if(item.valType == 'constant'){ //常数
                        value = item.value;
                    }else if(item.valType == 'sysData'){ //数据字典
                        if(item.value){
                            let valDataArr = item.value;
                            value =  valDataArr[valDataArr.length - 1] || '';
                        }
                    }else if(item.valType == 'sysTime') { //当前系统时间
                        if(item.value){
                            value = this.viewDateFormat(new Date(), item.value);
                        }
                    }else if(item.valType == 'equilibrium'){ //外部参数
                        value = this.listOutParam[item.value || ''] || '';
                    }
                    //执行语句
                    if(operaSign == "eq"){
                        condition = (param == value);
                    }else if(operaSign == ">" || operaSign == "<" || operaSign == ">=" || operaSign == "<="){
                        let ret = this.transType(param,value);
                        param = ret.param;
                        value = ret.value;
                        if(operaSign == ">"){
                            condition = (param > value);
                        }else if(operaSign == "<"){
                            condition = (param < value);
                        }else if(operaSign == ">="){
                            condition = (param >= value);
                        }else if(operaSign == "<=") {
                            condition = (param <= value);
                        }
                    }else if(operaSign == "ne"){
                        condition = (param != value);
                    }else if(operaSign == "in"){
                        if(value.includes(",")){
                            let arr=value.split(",") || [];
                            condition =arr.includes(param);
                        }else{
                            condition = (param.indexOf(value) > -1);
                        }
                    }else if(operaSign == "not in"){
                        if(value.includes(",")){
                            let arr=value.split(",") || [];
                            condition =!arr.includes(param)
                        }else{
                            condition = (param.indexOf(value) > -1);
                        }
                        condition = (param.indexOf(value) == -1);
                    }else if (operaSign == "be in"){// 被包含
                        if(param.includes(",")){
                            let arr=param.split(",") || [];
                            condition =arr.includes(value);
                        }else {
                            condition = (value.indexOf(param) > -1);
                        }
                    }else if(operaSign == "be not in"){ //不被包含
                        if(param.includes(",")){
                            let arr=param.split(",") || [];
                            condition =!arr.includes(value)
                        }else{
                            condition = (value.indexOf(param) > -1);
                        }
                        condition = (value.indexOf(param) == -1);
                    }else if(operaSign == "is null"){
                        condition = (!param);
                    }else if(operaSign == "is not null"){
                        condition = (!!param);
                    }
                    reultFunc += condition;
                    if(item.connectSignRight){
                        reultFunc += item.connectSignRight;
                    }
                });
                let funcBody = "let result = " + reultFunc +";"+"\n";
                funcBody+= "return result;";
                let result = false;
                try {
                    let serviceName = (window.SERVICE_NAME || {});
                    let adminServeName = serviceName.admin || "/admin/";
                    let formServeName = serviceName.form || "/form/";
                    let flowServeName = serviceName.flow || "/flow/";
                    let oaServeName = serviceName.oa || "/oaproject/";
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/admin/",adminServeName);
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/form/",formServeName);
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/flow/",flowServeName);
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/oaproject/",oaServeName);
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/oaadmin/",adminServeName);
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/oaform/",formServeName);
                    // funcBody = this.platStringUtil.replaceAll(funcBody,"/oaflow/",flowServeName);
                    if(window.ADMIN_URL && (funcBody.indexOf("/admin/") > -1 || funcBody.indexOf("/oaadmin/") > -1)){
                        if(funcBody.indexOf("/admin/")  > -1){
                            funcBody = this.platStringUtil.replaceAll(funcBody,"/admin/", window.ADMIN_URL + "/");
                        }else{
                            funcBody = this.platStringUtil.replaceAll(funcBody,"/oaadmin/",window.ADMIN_URL + "/");
                        }
                    }
                    if(window.FLOW_URL && (funcBody.indexOf("/flow/") > -1 || funcBody.indexOf("/oaflow/") > -1)){
                        if(funcBody.indexOf("/flow/")  > -1){
                            funcBody = this.platStringUtil.replaceAll(funcBody,"/flow/", window.FLOW_URL + "/");
                        }else{
                            funcBody = this.platStringUtil.replaceAll(funcBody,"/oaflow/",window.FLOW_URL + "/");
                        }
                    }
                    if(window.FORM_RENDER_URL && (funcBody.indexOf("/form/")  > -1|| funcBody.indexOf("/oaform/") > -1)){
                        if(funcBody.indexOf("/form/")  > -1){
                            funcBody = this.platStringUtil.replaceAll(funcBody,"/form/", window.FORM_RENDER_URL + "/");
                        }else{
                            funcBody = this.platStringUtil.replaceAll(funcBody,"/oaform/",window.FORM_RENDER_URL + "/");
                        }
                    }
                    if(window.OA_URL && (funcBody.indexOf("/project/") > -1 || funcBody.indexOf("/oaproject/") > -1)){
                        if(funcBody.indexOf("/project/")  > -1){
                            funcBody = this.platStringUtil.replaceAll(funcBody,"/project/", window.OA_URL + "/");
                        }else{
                            funcBody = this.platStringUtil.replaceAll(funcBody,"/oaproject/",window.OA_URL + "/");
                        }
                    }
                    funcBody = this.platStringUtil.replaceAll(funcBody,"window.JAVA_URL","''");
                    funcBody = this.platStringUtil.replaceAll(funcBody,"JAVA_URL","''");
                    funcBody = this.platStringUtil.replaceAll(funcBody,"window.baseUrl","''");
                    funcBody = this.platStringUtil.replaceAll(funcBody,"baseUrl","''");
                    result = new Function(funcBody)();
                }catch (e) {
                    result = false;
                    console.log("隐藏条件条件脚本执行错误！",e);
                }
                // console.log("result....",result);
                this.$set(this.formBtnVisbleObj,btnId,result);
            });
        },
        getUserBackfillData(){ //查询用户回填记录
            let queryParam = {"userId": this.loginUser.id, "preKey": this.userBackfillKey};
            return new Promise(resolve => {
                this.spcpFormAxios.post(this.api.plFormUserPreferences.find, queryParam).then(res => {
                    // console.log('ress',res);
                    if (res.data.length > 0){
                        this.userBackfillDataId = res.data[0].id;
                    }
                    resolve(res.data[0]);
                })
            })
        },
        //用户信息回填新增/修改
        userBackfillSaveData(optType){
            optType = optType || "add";
            let userBackfillObj = {};
            this.userBackfillArr.forEach(item => {
                let fieldId = item.fieldId;
                if(item.controlType == 'cascadeSelect') {
                    fieldId.split(",").forEach(key => {
                        userBackfillObj[key] = this.optFormData[key];
                    })
                }else {
                    userBackfillObj[fieldId] = this.optFormData[fieldId];
                }
                // switch (item.controlType) {
                //     case "cascadeSelect":
                //         fieldId.split(",").forEach(key => {
                //             userBackfillObj[key] = this.optFormData[key];
                //         })
                //         break;
                //     default:
                //         userBackfillObj[fieldId] = this.optFormData[fieldId];
                //         break;
                // }
            })
            let paramUserBackfillObj = JSON.stringify(userBackfillObj);
            let addParam = {
                "userId": this.loginUser.id,
                "preKey": this.userBackfillKey,
                "preJson": paramUserBackfillObj
            };
            // console.log('addParam',addParam,this.loginUser);
            let updateParam = {"id": this.userBackfillDataId, "preJson": paramUserBackfillObj};
            let paramObj = optType === "add" ? addParam : updateParam;
            this.spcpFormAxios.post(this.api.plFormUserPreferences.url + `/${optType}`, paramObj).then(res => {
                if (res && res.data && res.data.operateSuccess) {
                    this.userBackfillDataId = res.data.operateObj.id;
                    //更新用户信息回填缓存信息
                    let userBackfillData = {
                        "ID": this.userBackfillDataId,
                        "USER_ID": this.loginUser.id,
                        "PRE_KEY": this.userBackfillKey,
                        "PRE_JSON": paramUserBackfillObj
                    }
                    let userBackfillObj = this.PUBLIC_CACHE_UTIL.DATA_OBJ['userBackfill'];
                    userBackfillObj[this.userBackfillKey] = userBackfillData;
                    this.PUBLIC_CACHE_UTIL.setPublicCacheData('userBackfill',userBackfillObj);
                }
            });
        },
        async onEyeChange(field) {
            let vm = this;
            let type = this.optFormData[field].indexOf("*") !== -1;
            let data;
            if (type) {
                if (JSON.stringify(vm.decryptFormData) === "{}") {
                    await vm.loadDecryptFormData();
                }
                data = vm.decryptFormData;
            } else {
                data = vm.initFormData;
            }
            let val = "";
            Object.keys(data).forEach(id=>{
                if(field === id) {
                    val = data[id];
                }
            });
            vm.optFormData[field] = val;
        },
        setFormSkin(){
            if ("main-form-content" === this.tableviewsData.formSkin || !this.tableviewsData.formSkin) {
                let className = "pl-el-form";
                let skinType = this.listOutParam['skinType'] || this.outParam['skinType'];
                if (skinType === "dark") {
                    className += " pl-el-form-dark";
                }
                return className;
            }
            if ("main-form-simplicity" === this.tableviewsData.formSkin) {
                return "pl-el-form-simplicity";
            }
        },
        setFormDarkSkin() {
            let currBgColor = "#fff";
            if (this.skinType === "dark") {
                currBgColor = "transparent";
            }
            return {
                '--sasp-dark-bgcolor': this.skinBackground,
                'width': '100%',
                'height': '100%',
                'box-sizing': 'border-box',
                'padding': '5px 0',
                'background-color': currBgColor,
                'overflow-y': 'auto'
            };
        },
        /**
         * 手动设置下拉框的备选项
         */
        setDataOptions(field,options){
            options = options || [];
            if(options.length > 0){
                let option = options[0];
                if(option.hasOwnProperty("id") && option.hasOwnProperty("dataName")){
                    options.forEach(item => {
                        item["label"] = item.dataName;
                        item["value"] = item.id;
                    })
                }
                if(!option.hasOwnProperty("label") || !option.hasOwnProperty("value")){
                    console.log("属性中要包含label与value！");
                    return;
                }
            }
            let fieldRef = field;
            Object.keys(this.fieldIdName).forEach(fieldId => {
                if(this.fieldIdName[fieldId] === field){
                    fieldRef = fieldId;
                }
            })
            let dataSetting = this.dataAllObj[fieldRef];
            if(!dataSetting){
                console.log("设置"+ field +"下拉备选项时未获取到组件!");
            }else{
                dataSetting.selectType = "select"; // 将下拉框的属性转换为自定义select
                dataSetting.optionSetting = options;
            }
        }
    }
}
export default tableFormMixin;
